      program VIEW
** Visualize crystal structures created by HARDPACK
** version 11.07.1998
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS, XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
** PAR(K)        r parameter no. K
** IND(I)        i number of first parameter line of structure no. I
** ATIND(I)      i number of first atom line of structure no. I

      parameter(PI=3.14159265)
      integer*2 IXKEY
      integer MXCOL
      real F,PC,XC(3),XF(3),AMAX(3),AMIN(3)
      real TA(3),VOL, AF(8,3),AC(8,3)
      real MROT(3,3),YR(NUCLUS,3)
      real PAR(NUCLUS*6+NUSUB)
      integer RA(3,3),ILOOP,NL,IND(0:1000),ATIND(0:1000)
      character SYMM(3)*8,METHOD*12,TEXT*12
      real A(3,3), AI(3,3)
      common /TEST/ A,AI
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC
** F(I)     r Energy of structure no. I
** PC       r Packing coefficient of structure no. I
** AMIN(J)  r minimum x (y, z) coordinate of the drawing
** AMAX(J)  r maximum x (y, z) coordinate of the drawing
** NL       i line number in history file
** NSTRUC   i structure number in history file
** IND(J)   i line number of structure no. J (PARM line)

** LINE ORDER IN HISTORY FILE
** TI, AT, SY, SPGR, METHOD, LOOP, F:, NCLUS, SUMR, CELL, PARM

      integer LOPMIN,LOPMAX,FN,ICNT,ATPOS
      CHARACTER LINE*132, FELD*12, CLOOP*2
      character FNAME*40,LID*8,LOHI*8,BLTP*1,LOLD*5
      logical IDFND
      real ROTATE(3,3),ROTL(3,3),ROTR(3,3),ROTU(3,3),ROTD(3,3),DU(3,3)
      real RXYZ(3,NUMATM,NUSYM)
      common /RXYZ/ RXYZ

      data ((AF(I,J),J=1,3),I=1,8) /0.,0.,0., 1.,0.,0., 0.,1.,0.,
     $     0.,0.,1., 0.,1.,1., 1.,0.,1., 1.,1.,0., 1.,1.,1./
      data ((ROTD(I,J),J=1,3),I=1,3) /1,0,0, 0,.996195,-0.087156,
     $     0,.087156,.996195/
      data ((ROTU(I,J),J=1,3),I=1,3) /1,0,0, 0,.996195,0.087156,
     $     0,-.087156,.996195/
      data ((ROTR(I,J),J=1,3),I=1,3) /.996195,0,-0.087156, 0,1,0,
     $     .087156,0,.996195/
      data ((ROTL(I,J),J=1,3),I=1,3) /.996195,0,0.087156, 0,1,0,
     $     -.087156,0,.996195/
      CLOOP='00'
      UNAX=' '
      NC=1
      FN=10
      NS=0
      IAT=0
      ILOOP=0
      ISTER=0
      ISUM(1)=1
      ISUM(2)=1
      ISUM(3)=1
      NATM1=0
      NL=0
      NSTRUC=0
      SHIFT=.false.
      do 5 I=0,1000
        IND(I)=0
    5 continue
      do 10 I=1,3
        do 10 J=1,3
          ROTATE(I,J)=0.0
          IF(I.eq.J) ROTATE(I,J)=1.0
   10 continue

      CALL GRINIT(FAC,XMAX,MXCOL)
      open(unit=7,file='packmain.inp',err=970,status='old')
      read(7,'(a)') FNAME
      close(unit=7)
      IFN=index(FNAME,' ')
      open(unit=FN,file=FNAME(:IFN-1)//'.his',err=965,status='old')
      rewind(unit=FN)
** find position of all first parm and atom lines
      LOLD=' '
   15 continue
      read(fn,'(a)',err=15,end=16) LINE
      NL=NL+1
      IF(LINE(1:5).EQ.'PARM '.AND.LOLD.NE.'PARM ') THEN
        NSTRUC=NSTRUC+1
        IND(NSTRUC)=NL
        ATIND(NSTRUC)=ATPOS
      END IF
      IF((LINE(1:5).EQ.'ATOM '.AND.LOLD.NE.'ATOM ').OR.
     $   (LINE(1:3).EQ.'AT '.AND.LOLD(1:3).NE.'AT ')) THEN
        ATPOS=NL
      END IF

      LOLD=LINE(1:5)
      goto 15
   16 continue
      NL=0
      NP=0
      NSTRMX=NSTRUC
      NSTRUC=0
      rewind(unit=FN)
      LOPMIN=99999
      LOPMAX=-99999

   20 continue

      READ(FN,'(A)',ERR=20,END=100) LINE
      NL=NL+1
***
      LID = LOHI(LINE(1:8))
      IF(LID(1:3).NE.'AT'.AND.LID(1:5).NE.'ATOM'.AND.IAT.EQ.0) IAT=1

** TITLE
      IF(LID(1:6).EQ.'TITLE ') THEN
	IDFND=.true.
	TITLE = LINE(7:80)
	NATM1=0
	NS=0
        NC=1
      ELSE IF(LID(1:5).EQ.'TITL ') THEN
	IDFND=.true.
	TITLE = LINE(6:80)
	NATM1=0
	NS=0
        NC=1
      ELSE IF(LID(1:3).EQ.'TI ') THEN
	IDFND=.true.
	TITLE = LINE(4:80)
	NATM1=0
        NS=0
        NC=1
      END IF

*** CELL CONSTANTS
      IF(LID(1:5).EQ.'CELL ') THEN
	IDFND=.true.
        DO 440 J=1,6
	  CALL LINCUT(LINE,FELD)
	  READ(FELD,'(BN,F12.0)',ERR=20) CELL(J)
	  IF(J.GT.3) CELL(J)=CELL(J)/180.0*PI
  440   CONTINUE
        call CALSYM
      END IF
***
** ATOM NAMES, POTENTIAL TYPES, COORDINATES, CHARGES
      IF(LID(1:5).EQ.'ATOM '.OR.LID(1:3).EQ.'AT ') THEN
	IDFND = .true.
        IF(IAT.EQ.1) THEN
          IAT=0
          NATM1=0
        END IF
** DEFINE UNIQUE AXIS
	if(UNAX.eq.' ') then
	  if(abs(CELL(6)-PI/2).gt.1e-4) UNAX = 'C'
	  if(abs(CELL(5)-PI/2).gt.1e-4) UNAX = 'B'
	  if(abs(CELL(4)-PI/2).gt.1e-4) UNAX = 'A'
	end if
	if(UNAX.eq.' ') then
	  if(abs(CELL(1)-CELL(2)).lt.1e-4.and.
     $       abs(CELL(1)-CELL(3)).lt.1e-4.and.
     $       abs(CELL(4)-CELL(5)).lt.1e-4.and.
     $       abs(CELL(4)-CELL(6)).lt.1e-4.and.
     $       abs(CELL(4)-PI/2).gt.1e-4) UNAX = 'R'
	end if
	if(UNAX.eq.' ') then
	  if(abs(CELL(1)-CELL(2)).gt.1e-4) UNAX = 'C'
	  if(abs(CELL(1)-CELL(3)).gt.1e-4) UNAX = 'B'
	  if(abs(CELL(2)-CELL(3)).gt.1e-4) UNAX = 'A'
	end if
	if(UNAX.eq.' ') UNAX = 'A'
	NATM1 = NATM1+1
        ICLUS(NATM1)=NC
        CALL LINCUT(LINE,FELD)
        ATNAME(NATM1)=FELD(1:8)
        CALL LINCUT(LINE,FELD)
        DO 460 J=1,3
          CALL LINCUT(LINE,FELD)
          READ(FELD,'(BN,F12.0)',ERR=20) XYZC(NATM1,J)
  460   CONTINUE
	CALL LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) LSUB(NATM1)
      END IF

** MOLE
      IF(LID(1:5).eq.'MOLE ') THEN
	IDFND=.true.
        NC = NC + 1
      END IF

** SYMM
      IF(LID(1:3).eq.'SY ') THEN
	IDFND=.true.
	NS = NS + 1
	if(NS.gt.NUSYM) then
	  write(2,'(/1x,a/)') 'WARNING - TOO MANY SYMM LINES.'
	  write(*,'(/1x,a/)') 'WARNING - TOO MANY SYMM LINES.'
	  NS = NUSYM
	  GOTO 20
	end if
	CALL LINCUT(LINE,FELD)
	SYMM(1)=LOHI(FELD(1:8))
	IS=index(SYMM(1),',')
	if(IS.ne.0) SYMM(1)(IS:IS)=' '
	CALL LINCUT(LINE,FELD)
	SYMM(2)=LOHI(FELD(1:8))
	IS=index(SYMM(2),',')
	if(IS.ne.0) SYMM(2)(IS:IS)=' '
	CALL LINCUT(LINE,FELD)
	SYMM(3)=LOHI(FELD(1:8))
	IS=index(SYMM(3),',')
	if(IS.ne.0) SYMM(3)(IS:IS)=' '
        TA(1)=0.0
        TA(2)=0.0
        TA(3)=0.0
	CALL SYMTRN(SYMM,RA,TA)
        do 480 J=1,3
          T(NS,J)=TA(J)
          do 480 K=1,3
            R(NS,J,K)=RA(J,K)
  480   continue
        call SYMMCL(BLTP,ICNT)
      END IF

** SPGR
      IF(LID(1:5).eq.'SPGR ') THEN
	IDFND=.true.
	CALL LINCUT(LINE,FELD)
        SPG=LOHI(FELD(1:8))
	CALL LINCUT(LINE,FELD)
        UNAX=LOHI(FELD(1:8))
      END IF

** SUMR
      IF(LID(1:5).EQ.'SUMR ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=20) SUMR
	call LINCUT(LINE,FELD)
        if(FELD.eq.' ') then
          ISUM(1)=0
          ISUM(2)=0
          ISUM(3)=0
        else
          READ(FELD,'(BN,I12)',ERR=20) ISUM(2)
          call LINCUT(LINE,FELD)
          READ(FELD,'(BN,I12)',ERR=20) ISUM(3)
          ISUM(1)=nint(SUMR)
        end if
      END IF

** METHOD
      IF(LID(1:7).EQ.'METHOD ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
        METHOD=FELD
      END IF

*** PARAMETERS
      IF(LID(1:5).EQ.'PARM ') THEN
	IDFND=.true.
	NP=NP+1
        do 500 J=1,6
	  call LINCUT(LINE,FELD)
          READ(FELD,'(BN,F12.0)',ERR=20) PAR((NP*6)-6+J)
  500   continue
        if(NP.ne.NCLUS+(NSUB+5)/6) goto 800
        NSTRUC=min(NSTRUC+1,NSTRMX)
        IND(NSTRUC)=NL

 510   continue

        CALL PLOT(0.0,0.0,23)
        CALL NEWPEN(MXCOL-1)
        WRITE(TEXT,'(A,I3)') 'LOOP: ',ILOOP
        CALL GTEXT(1,68,TEXT)
        WRITE(TEXT,'(G11.4)') F
        CALL GTEXT(2,68,TEXT)
        CALL GTEXT(3,68,'kJ/mol')
        WRITE(TEXT,'(A,F9.2)') 'PC',PC
        CALL GTEXT(4,68,TEXT)
        CALL GTEXT(5,68,METHOD)
        CALL GTEXT(6,68,SPG)
        CALL GTEXT(8,68,'KEYS:')
        CALL GTEXT(9,68,'Rotation:')
        CALL GTEXT(10,68,'L: left')
        CALL GTEXT(11,68,'R: right')
        CALL GTEXT(12,68,'U: up')
        CALL GTEXT(13,68,'D: down')
        CALL GTEXT(14,68,'View Mode:')
        IF(ISTER.eq.0)  CALL NEWPEN(2)
        CALL GTEXT(15,68,'M: mono')
        IF(ISTER.eq.0)  CALL NEWPEN(MXCOL-1)
        IF(ISTER.eq.-1)  CALL NEWPEN(2)
        CALL GTEXT(16,68,'C: c. stereo')
        IF(ISTER.eq.-1)  CALL NEWPEN(MXCOL-1)
        IF(ISTER.eq.1)  CALL NEWPEN(2)
        CALL GTEXT(17,68,'P: p. stereo')
        IF(ISTER.eq.1)  CALL NEWPEN(MXCOL-1)
        CALL GTEXT(19,68,'Save File:')
        CALL GTEXT(20,68,'S: SCHAKAL')
        CALL GTEXT(21,68,'T: POWCEL')
        CALL GTEXT(22,68,'F: forward')
        CALL GTEXT(23,68,'B: backward')
        CALL GTEXT(24,68,'Q: quit')
        AMIN(1)=1e7
        AMIN(2)=1e7
        AMIN(3)=1e7
        AMAX(1)=-1e7
        AMAX(2)=-1e7
        AMAX(3)=-1e7
        IF(ISUM(1).eq.0.and.ISUM(2).eq.0.and.ISUM(3).eq.0) GOTO 565
        DO 560 I=1,8
          DO 520 J=1,3
            XF(J)=AF(I,J)
  520     CONTINUE
          CALL FRACRT(XF,XC,CELL,VOL,1,UNAX,.false.,IERR)
          DO 540 J=1,3
            AC(I,J) = XC(J)
  540     CONTINUE
          DO 550 J=1,3
            if(AC(I,J).lt.AMIN(J)) AMIN(J)=AC(I,J)
            if(AC(I,J).gt.AMAX(J)) AMAX(J)=AC(I,J)
  550     CONTINUE
  560   CONTINUE
  565   CONTINUE
        do 600 I=1,NATM1
          do 580 J=1,3
            RXYZ(J,I,1)=XYZC(I,J)
  580     continue
  600   continue
        do 620 K=1,NSUB
          SUBROT(K)=PAR(NUCLUS*6+K)
  620   continue
        do 640 K=1,NSUB
          call SBROT(K,SUBROT(K))
  640   continue
        do 700 L=1,NCLUS
          do 660 J=1,3
            XYZS(L,J) = PAR((L*6)-6+J)
            XYZSC(J,L,1) = XYZS(L,1)*A(J,1)+
     $                     XYZS(L,2)*A(J,2)+
     $                     XYZS(L,3)*A(J,3)
  660     continue
          do 680 J=4,6
            YR(L,J-3) = PAR((L*6)-6+J)
  680     continue
          call ROTEUL(L,YR,MROT,.true.)
  700   continue
        DO 760 I=1,NATM1
          do 740 J=1,3
            RXYZ(J,I,1) = RXYZ(J,I,1) + XYZSC(J,ICLUS(I),1)
  740     continue
  760   CONTINUE
        do 780 M=1,NS
          N=ISYM(M)
          N1=abs(N)
          do 755 I=1,NATM1
            do 730 J=1,3
              RXYZ(J,I,M)=sign(1,N)*(RN(N1,J,1)*RXYZ(1,I,1)+
     $                               RN(N1,J,2)*RXYZ(2,I,1)+
     $                               RN(N1,J,3)*RXYZ(3,I,1))+
     $                      T(N1,1)*A(J,1)+T(N1,2)*A(J,2)+T(N1,3)*A(J,3)
  730       CONTINUE
            do 745 J=1,3
              if(RXYZ(J,I,M).lt.AMIN(J)) AMIN(J)=RXYZ(J,I,M)
              if(RXYZ(J,I,M).gt.AMAX(J)) AMAX(J)=RXYZ(J,I,M)
             IF(ISUM(1).eq.0.and.ISUM(2).eq.0.and.ISUM(3).eq.0) GOTO 745
            if(RXYZ(J,I,M)+A(J,1).lt.AMIN(J)) AMIN(J)=RXYZ(J,I,M)+A(J,1)
            if(RXYZ(J,I,M)+A(J,2).lt.AMIN(J)) AMIN(J)=RXYZ(J,I,M)+A(J,2)
            if(RXYZ(J,I,M)+A(J,3).lt.AMIN(J)) AMIN(J)=RXYZ(J,I,M)+A(J,3)
              if(RXYZ(J,I,M)+A(J,1)+A(J,2).lt.AMIN(J))
     $                                 AMIN(J)=RXYZ(J,I,M)+A(J,1)+A(J,2)
              if(RXYZ(J,I,M)+A(J,1)+A(J,3).lt.AMIN(J))
     $                                 AMIN(J)=RXYZ(J,I,M)+A(J,1)+A(J,3)
            if(RXYZ(J,I,M)+A(J,1).gt.AMAX(J)) AMAX(J)=RXYZ(J,I,M)+A(J,1)
            if(RXYZ(J,I,M)+A(J,2).gt.AMAX(J)) AMAX(J)=RXYZ(J,I,M)+A(J,2)
            if(RXYZ(J,I,M)+A(J,3).gt.AMAX(J)) AMAX(J)=RXYZ(J,I,M)+A(J,3)
              if(RXYZ(J,I,M)+A(J,1)+A(J,2).gt.AMAX(J))
     $                                 AMAX(J)=RXYZ(J,I,M)+A(J,1)+A(J,2)
              if(RXYZ(J,I,M)+A(J,1)+A(J,3).lt.AMIN(J))
     $                                 AMIN(J)=RXYZ(J,I,M)+A(J,1)+A(J,3)
  745       continue
  755     CONTINUE
  780   CONTINUE
        FAC=XMAX/sqrt((AMAX(1)-AMIN(1)+.3)**2+(AMAX(2)-AMIN(2)+.3)**2+
     $                (AMAX(3)-AMIN(3)+.3)**2)
        CALL FACTOR(FAC)
        if(ISTER.ne.0) CALL FACTOR(FAC/2.0)
        IF(ISUM(1).ne.0.or.ISUM(2).ne.0.or.ISUM(3).ne.0)
     $                       call PLTCEL(AC,FAC,AMIN,AMAX,ROTATE,ISTER)
        call PLTMOL(FAC,AMIN,AMAX,MXCOL,ROTATE,ISTER)
  790   CONTINUE
** Auf Tastendruck warten
        KEY=IXKEY()
** Quit
        IF(KEY.EQ.ICHAR('Q').OR.KEY.EQ.ICHAR('q')) GOTO 100
        if(key.eq.ichar('w')) write(*,'(10i7)') ind
** Mono
        IF(KEY.EQ.ICHAR('M').OR.KEY.EQ.ICHAR('m')) THEN
          ISTER=0
          GOTO 510
** Cross-stereo
        ELSE IF(KEY.EQ.ICHAR('C').OR.KEY.EQ.ICHAR('c')) THEN
          ISTER=-1
          CALL FACTOR(FAC/2)
          GOTO 510
** Parallel-stereo
        ELSE IF(KEY.EQ.ICHAR('P').OR.KEY.EQ.ICHAR('p')) THEN
          ISTER=1
          CALL FACTOR(FAC/2)
          GOTO 510
        ELSE IF(KEY.EQ.ICHAR('L').OR.KEY.EQ.ICHAR('l')) THEN
          DO 300 I=1,3
            DO 300 J=1,3
              DU(I,J)=ROTL(I,1)*ROTATE(1,J)+ROTL(I,2)*ROTATE(2,J)+
     $                ROTL(I,3)*ROTATE(3,J)
  300     CONTINUE
          DO 310 I=1,3
            DO 310 J=1,3
              ROTATE(I,J)=DU(I,J)
  310     CONTINUE
          GOTO 510
        ELSE IF(KEY.EQ.ICHAR('R').OR.KEY.EQ.ICHAR('r')) THEN
          DO 320 I=1,3
            DO 320 J=1,3
              DU(I,J)=ROTR(I,1)*ROTATE(1,J)+ROTR(I,2)*ROTATE(2,J)+
     $                ROTR(I,3)*ROTATE(3,J)
  320     CONTINUE
          DO 330 I=1,3
            DO 330 J=1,3
              ROTATE(I,J)=DU(I,J)
  330     CONTINUE
          GOTO 510
        ELSE IF(KEY.EQ.ICHAR('U').OR.KEY.EQ.ICHAR('u')) THEN
          DO 340 I=1,3
            DO 340 J=1,3
              DU(I,J)=ROTU(I,1)*ROTATE(1,J)+ROTU(I,2)*ROTATE(2,J)+
     $                ROTU(I,3)*ROTATE(3,J)
  340     CONTINUE
          DO 350 I=1,3
            DO 350 J=1,3
              ROTATE(I,J)=DU(I,J)
  350     CONTINUE
          GOTO 510
        ELSE IF(KEY.EQ.ICHAR('D').OR.KEY.EQ.ICHAR('d')) THEN
          DO 360 I=1,3
            DO 360 J=1,3
              DU(I,J)=ROTD(I,1)*ROTATE(1,J)+ROTD(I,2)*ROTATE(2,J)+
     $                ROTD(I,3)*ROTATE(3,J)
  360     CONTINUE
          DO 370 I=1,3
            DO 370 J=1,3
              ROTATE(I,J)=DU(I,J)
  370     CONTINUE
          GOTO 510

** Save coordinates as SCHAKAL or POWDER CELL
        ELSE IF(KEY.EQ.ICHAR('S').OR.KEY.EQ.ICHAR('s')) THEN
          CALL NEWPEN(10)
          CALL GTEXT(1,1,'Save SCHAKAL File as '//FNAME(:IFN-1)//'.d'//
     $                   CLOOP//'. OK? (Y/N)')
          KEY=IXKEY()
          IF(CHAR(KEY).EQ.'Y'.OR.CHAR(KEY).EQ.'y') THEN
            OPEN(UNIT=9,FILE=FNAME(:IFN-1)//'.d'//CLOOP,ERR=980,
     $                                                 STATUS='unknown')
            CALL OUTPT4(9)
            CLOSE(UNIT=9)
          END IF
          CALL GTEXT(1,1,'                                            ')
          CALL NEWPEN(MXCOL-1)
        ELSE IF(KEY.EQ.ICHAR('T').OR.KEY.EQ.ICHAR('t')) THEN
          CALL NEWPEN(10)
          CALL GTEXT(1,1,'Save POWDER CELL File as '//FNAME(:IFN-1)//
     $                   '.r'//CLOOP//'. OK? (Y/N)')
          KEY=IXKEY()
          IF(CHAR(KEY).EQ.'Y'.OR.CHAR(KEY).EQ.'y') THEN
            OPEN(UNIT=9,FILE=FNAME(:IFN-1)//'.r'//CLOOP,ERR=980,
     $                                                 STATUS='unknown')
            CALL OUTPT5(9)
            CLOSE(UNIT=9)
          END IF
          CALL GTEXT(1,1,'                                            ')
          CALL NEWPEN(MXCOL-1)
** Backward
        ELSE IF(KEY.EQ.ICHAR('B').OR.KEY.EQ.ICHAR('b')) THEN
          NSTRUC=max(0,NSTRUC-2)
          if(NSTRUC.eq.0) then
            rewind(FN)
            goto 800
          else
            call GO(FN,NL,NSTRUC,NATM1,IND,ATIND)
          end if
** Forward
        ELSE IF(KEY.EQ.ICHAR('F').OR.KEY.EQ.ICHAR('f')) THEN
          IF(NSTRUC.LT.NSTRMX) GOTO 800
          IF(NSTRUC.GE.NSTRMX) GOTO 790
** 16 Steps backward
        ELSE IF(KEY.EQ.1073) THEN
          NSTRUC=max(0,NSTRUC-16)
          if(NSTRUC.eq.0) then
            rewind(FN)
            goto 800
          else
            call GO(FN,NL,NSTRUC,NATM1,IND,ATIND)
          end if
** 16 Steps forward
        ELSE IF(KEY.EQ.1081) THEN
          NSTRUC=min(NSTRUC+16,NSTRMX)
          call GO(FN,NL,NSTRUC,NATM1,IND,ATIND)
        ELSE
          GOTO 790
        END IF
  800   CONTINUE
        FAC=10.0
        GOTO 20
      END IF

** LOOP
      IF(LID(1:5).EQ.'LOOP ') THEN
	IDFND=.true.
	NP=0
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) ILOOP
	if(ILOOP.lt.1.or.ILOOP.gt.359) write(2,'(/1x,a,i12/)') 
     $      'WARNING - ILLEGAL VALUE FOR ILOOP:',ILOOP
	if(ILOOP.lt.1.or.ILOOP.gt.359) write(*,'(/1x,a,i12/)') 
     $      'WARNING - ILLEGAL VALUE FOR ILOOP:',ILOOP
        if(ILOOP.lt.10) write(CLOOP(2:2),'(i1)') ILOOP
        if(ILOOP.ge.10.and.ILOOP.lt.100) write(CLOOP,'(i2)') ILOOP
        if(ILOOP.ge.100) write(CLOOP,'(a1,i1)') 
     $                  char(ichar('a')+(ILOOP-100)/10),mod(ILOOP,10)
	LOPMIN=min(ILOOP,LOPMIN)
	LOPMAX=max(ILOOP,LOPMAX)
      END IF

** ENERGY
      IF(LID(1:3).EQ.'F: ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=20) F
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=20) PC
      END IF

** NCLUS, NSUB

      IF(LID(1:6).EQ.'NCLUS ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) NCLUS
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) NSUB
      END IF

      if(.not.IDFND) then
	write(2,'(/1x,3a/)') 
     $      'WARNING - LINE ID ',LID,' not found.'
	write(*,'(/1x,3a/)') 
     $      'WARNING - LINE ID ',LID,' not found.'
      end if

      goto 20

  100 continue
      close(unit=FN)

** Programm-Ende
      CALL PLOT( 0.,0.,999)
      stop
  965 continue
      CALL PLOT( 0.,0.,999)
      print*,'ERROR - Error opening ',FNAME(:IFN-1)//'.his'
      print*,'Program stopped'
      stop
  970 continue
      CALL PLOT( 0.,0.,999)
      print*,'ERROR - Error opening packmain.inp'
      print*,'Program stopped'
      stop
  980 continue
      end
**
      subroutine LINCUT(LINE,FELD)
** Searches for the first and second position in the character variable LINE
** where a space or a comma is followed by a character which is neither a
** space or a comma. The region between both positions is transferred to
** the character variable FELD and afterwards cut from the variable LINE.
*** VERSION 6.3.92
      implicit real (a-h,o-z)
      CHARACTER LINE*132, FELD*12
      INTEGER CUT
************************************************************************
      FELD=' '
      CUT=0
      DO 10 I=1,131
	IF((LINE(I:I).EQ.' '.OR.LINE(I:I).EQ.',').AND.
     $     (LINE(I+1:I+1).NE.' '.AND.LINE(I+1:I+1).NE.',')) THEN
	  LINE = LINE(I+1:)
	  CUT=1
	  GOTO 20
	END IF
   10 CONTINUE
   20 CONTINUE
      IF(CUT.NE.1) LINE = ' '
      FELD = LINE
      DO 30 I=1,131
	IF((LINE(I:I).EQ.' '.OR.LINE(I:I).EQ.',').AND.
     $     (LINE(I+1:I+1).NE.' '.AND.LINE(I+1:I+1).NE.',')) THEN
	  FELD = LINE(:I)
	  RETURN
	END IF
   30 CONTINUE
      END
**      
      function LOHI(STRING)
** converts small letters to capital letters
      character*8 STRING,LOHI
      integer IC
      IC = ichar('a')-ichar('A')
      do 10 I=1,8
	if(STRING(I:I).ge.'a'.and.STRING(I:I).le.'z') then
	  LOHI(I:I) = char(ichar(STRING(I:I))-IC)
	else
	  LOHI(I:I) = STRING(I:I)
	end if
   10 continue
      end
**
      subroutine GO(FN,NL,NSTRUC,NATM1,IND,ATIND)
** Go to the first parameter line of structure no. NSTRUC and read the
** corresponding atom coordinates and subrotation indices
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer FN,NL,NSTRUC,IND(0:1000),ATIND(1:1000)
      integer LSUB(NUMATM),ILOOP,ISUM(3)
      real XYZC(NUMATM,3),F,PC,CELL(6),SUMR
      character ATNAME(NUMATM)*8
      CHARACTER LINE*132, FELD*12, LOHI*8, LID*8
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC
** LINE ORDER IN HISTORY FILE
** TI, AT, SY, SPGR, METHOD, LOOP, F:, NCLUS, SUMR, CELL, PARM

      NL=0
      I=0

** go to AT line and read atom names and coordinates
      REWIND(FN)
      do 10 I=1,ATIND(NSTRUC)-1
        READ(FN,'(A)',ERR=10,END=100)
   10 continue
      NATM1=0
   30 CONTINUE
      READ(FN,'(A)',ERR=30,END=100) LINE
      LID = LOHI(LINE(1:8))
      IF(LID(1:5).NE.'ATOM '.AND.LID(1:3).NE.'AT ') GOTO 55
      NATM1=NATM1+1
      CALL LINCUT(LINE,FELD)
      ATNAME(NATM1)=FELD(1:8)
      CALL LINCUT(LINE,FELD)
      DO 50 J=1,3
        CALL LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=50) XYZC(NATM1,J)
   50 CONTINUE
      CALL LINCUT(LINE,FELD)
      READ(FELD,'(BN,I12)',ERR=30) LSUB(NATM1)
      GOTO 30
   55 CONTINUE

** goto LOOP, F:, SUMR, CELL and PARM line
      REWIND(FN,ERR=100)
      do 60 I=1,IND(NSTRUC)-6
        READ(FN,'(A)',ERR=60,END=100) LINE
   60 continue
** LOOP
      LID = LOHI(LINE(1:8))
      IF(LID(1:5).EQ.'LOOP') THEN
        READ(FELD,'(BN,I12)',ERR=100) ILOOP
      END IF
      READ(FN,'(A)',ERR=100,END=100) LINE
      LID = LOHI(LINE(1:8))
      IF(LID(1:3).EQ.'F: ') THEN
        call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=100) F
        call LINCUT(LINE,FELD)
        call LINCUT(LINE,FELD)
        call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=100) PC
      END IF
      READ(FN,'(A)',ERR=100,END=100) LINE
      READ(FN,'(A)',ERR=100,END=100) LINE
      LID = LOHI(LINE(1:8))
** SUMR
      IF(LID(1:5).EQ.'SUMR ') THEN
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=35) SUMR
	call LINCUT(LINE,FELD)
        if(FELD.eq.' ') then
          ISUM(1)=0
          ISUM(2)=0
          ISUM(3)=0
        else
          READ(FELD,'(BN,I12)',ERR=35) ISUM(2)
          call LINCUT(LINE,FELD)
          READ(FELD,'(BN,I12)',ERR=35) ISUM(3)
          ISUM(1)=nint(SUMR)
        end if
      END IF
   35 CONTINUE
** CELL
      READ(FN,'(A)',ERR=100,END=100) LINE
      LID = LOHI(LINE(1:8))
      IF(LID(1:5).EQ.'CELL ') THEN
        DO 40 J=1,3
          call LINCUT(LINE,FELD)
          READ(FELD,'(BN,F12.0)',ERR=40) CELL(J)
   40   CONTINUE
      END IF
  100 continue
      NL=IND(NSTRUC)
      return
      end
**
      subroutine FRACRT(XYZF,XYZ2,CELL,VOL,IDIR,UNAX,OLD,IERR)
** TRANSFORMS FRACTIONAL COORDINATES XYZF TO CARTESIAN COORDINATES
** XYZ2 AND VICE VERSA.
** Version 05.03.1996
** CELL: d cell constants, angles in radian measure
** XYZ:  d fractional coordinates
** XYZ2: d cartesian coordinates
** A:    d transformation matrix fractional -> cartesian
** AI:   d transformation matrix cartesian  -> fractional
** VOL:  d cell volume
** IDIR: i 1: fractional -> cartesian
**        -1: cartesian  -> fractional
** UNAX: c unique axis (a/A, b/B, c/C, r/R)
** OLD:  l .true.: use old transformation matrix
**         .false.: calculate new transformation matrix
** IERR: i 0: no error    
**         1: one angle is less than or equal to 1 deg. or one angle
**            is greater then 180 deg.
**         2: one cell edge is less than 1
**         3: IDIR is neither -1 nor 1
**         4: sum of angles is greater or equal 360 deg.
**         5: ((cos(beta)-cos(gamma)*cos(alpha))/sin(alpha))**2 +
**            cos(gamma)**2 
**            or corresponding expressions are greater than 1.0
************************************************************************
** definition of cartesian axes (unique axis=a):
** x-axis parallel to a-axis
** y-axis in a-b-plane, on the same side as b-axis
** z-axis perpendicular to x- and y-axis (right-hand system)
** (unique axis=b):
** x-axis perpendicular to y- and z-axis (right-hand system)
** y-axis parallel to b-axis
** z-axis in b-c-plane, on the same side as c-axis
** (unique axis=c):
** x-axis in c-a-plane, on the same side as a-axis
** y-axis perpendicular to z- and x-axis (right-hand system)
** z-axis parallel to c-axis
************************************************************************
      implicit real (a-h,o-z)
      parameter(PI=3.141592653589793d0,PI20=PI/20d0)
      real CELL(6), XYZF(3), XYZ2(3), VOL
      real D, C1,C2,C3,S1,S2,S3
      integer IDIR, IERR
      character UNAX*1
      logical OLD
      real A(3,3), AI(3,3)
      common /TEST/ A,AI
************************************************************************
      IERR = 0
      if(OLD) goto 100
** calculate transformation matrix (fractional to cartesian)
      if(CELL(4).lt.PI20.or.CELL(5).lt.PI20.or.CELL(6).lt.PI20) then
	IERR = 1
	return
      end if
      if(CELL(4).ge.PI.or.CELL(5).ge.PI.or.CELL(6).ge.PI) then
	IERR = 1
	return
      end if
      C1 = COS(CELL(4))
      C2 = COS(CELL(5))
      C3 = COS(CELL(6))
      if(CELL(1).lt.1.0.or.CELL(2).lt.1.0.or.CELL(3).lt.1.0) then
	IERR = 2
	return
      end if
      if(CELL(4)+CELL(5)+CELL(6).ge.2*PI) then
	IERR = 4
	return
      end if
      if(UNAX.eq.' '.or.UNAX.eq.'a'.or.UNAX.eq.'A') then
	S3 = SIN(CELL(6))
	A(1,1) = CELL(1)
	A(1,2) = CELL(2)*C3
	A(2,1) = 0.0
	A(2,2) = CELL(2)*S3
	A(1,3) = CELL(3)*C2
	A(2,3) = CELL(3)*(C1-C2*C3)/S3
	A2 = (A(2,3)/CELL(3))**2+C2**2
	if(A2.gt.1.0) then
	  IERR = 5
	  return
	end if
	A(3,1) = 0.0
	A(3,2) = 0.0
	A(3,3) = CELL(3)*SQRT(1. - A2)
      else if(UNAX.eq.'b'.or.UNAX.eq.'B') then
	S1 = SIN(CELL(4))
	A(2,2) = CELL(2)
	A(2,3) = CELL(3)*C1
	A(3,3) = CELL(3)*S1
	A(2,1) = CELL(1)*C3
	A(3,1) = CELL(1)*(C2-C3*C1)/S1
	A(3,2) = 0.0
	A2 = (A(3,1)/CELL(1))**2+C3**2
	if(A2.gt.1.0) then
	  IERR = 5
	  return
	end if
	A(1,1) = CELL(1)*SQRT(1. - A2)
	A(1,2) = 0.0
	A(1,3) = 0.0
      else if(UNAX.eq.'c'.or.UNAX.eq.'C') then
	S2 = SIN(CELL(5))
	A(3,3) = CELL(3)
	A(3,1) = CELL(1)*C2
	A(1,1) = CELL(1)*S2
	A(3,2) = CELL(2)*C1
	A(1,2) = CELL(2)*(C3-C1*C2)/S2
	A(1,3) = 0.0
	A2 = (A(1,2)/CELL(2))**2+C1**2
	if(A2.gt.1.0) then
	  IERR = 5
	  return
	end if
	A(2,1) = 0.0
	A(2,2) = CELL(2)*SQRT(1. - A2)
	A(2,3) = 0.0
      else if(UNAX.eq.'r'.or.UNAX.eq.'R') then
	A(1,1) = 0.0
	A(1,2) = sqrt(0.5)*CELL(1)*SQRT(1.0-C1)
	A(1,3) = -A(1,2)
	A(2,1) = -2.0*A(1,2)/sqrt(3.0)
	A(2,2) = -A(2,1)/2.0
	A(2,3) = A(2,2)
	A(3,1) = SQRT(CELL(1)**2-A(2,1)**2)
	A(3,2) = A(3,1)
	A(3,3) = A(3,1)
      end if
      if(IDIR.ne.1.and.IDIR.ne.-1) then
	IERR = 3
	return
      end if
  100 continue
      if(UNAX.ne.'r'.and.UNAX.ne.'R') VOL = A(1,1)*A(2,2)*A(3,3)
      if(UNAX.eq.'r'.or.UNAX.eq.'R') then
	VOL = A(1,2)*A(2,3)*A(3,1) + A(1,3)*A(2,1)*A(3,2) -
     $        A(3,1)*A(2,2)*A(1,3) - A(2,1)*A(1,2)*A(3,3)
      end if
      if(IDIR.eq.1) then
	XYZ2(1) = A(1,1)*XYZF(1) + A(1,2)*XYZF(2) + A(1,3)*XYZF(3)
	XYZ2(2) = A(2,1)*XYZF(1) + A(2,2)*XYZF(2) + A(2,3)*XYZF(3)
	XYZ2(3) = A(3,1)*XYZF(1) + A(3,2)*XYZF(2) + A(3,3)*XYZF(3)
	return
      end if
      if(IDIR.eq.-1) then
	if(OLD) goto 200
** calculate inverse transformation matrix (cartesian to fractional)
	D = VOL
	AI(1,1) = (A(2,2)*A(3,3)-A(3,2)*A(2,3))/D
	AI(2,1) =-(A(2,1)*A(3,3)-A(3,1)*A(2,3))/D
	AI(3,1) = (A(2,1)*A(3,2)-A(3,1)*A(2,2))/D
	AI(1,2) =-(A(1,2)*A(3,3)-A(3,2)*A(1,3))/D
	AI(2,2) = (A(1,1)*A(3,3)-A(3,1)*A(1,3))/D
	AI(3,2) =-(A(1,1)*A(3,2)-A(3,1)*A(1,2))/D
	AI(1,3) = (A(1,2)*A(2,3)-A(2,2)*A(1,3))/D
	AI(2,3) =-(A(1,1)*A(2,3)-A(2,1)*A(1,3))/D
	AI(3,3) = (A(1,1)*A(2,2)-A(2,1)*A(1,2))/D
  200   continue
	XYZF(1) = AI(1,1)*XYZ2(1) + AI(1,2)*XYZ2(2) + AI(1,3)*XYZ2(3)
	XYZF(2) = AI(2,1)*XYZ2(1) + AI(2,2)*XYZ2(2) + AI(2,3)*XYZ2(3)
	XYZF(3) = AI(3,1)*XYZ2(1) + AI(3,2)*XYZ2(2) + AI(3,3)*XYZ2(3)
	return
      end if
      end
**      
      subroutine SYMTRN(XYZ,R,T)
**** Dieses Unterprogramm interpretiert Symmetrieoperationen in 
**** algebraischer Schreibweise
      implicit real (a-h,o-z)
      parameter(NUSYM=24)
      character XYZ(3)*8
      real T(3)
      integer R(3,3)
************************************************************************
      do 10 J=1,3
	if(index(XYZ(J),'1').ne.0) T(J)=1
	if(index(XYZ(J),'2/').ne.0) T(J)=2
	if(index(XYZ(J),'3/').ne.0) T(J)=3
	if(index(XYZ(J),'4/').ne.0) T(J)=4
	if(index(XYZ(J),'5/').ne.0) T(J)=5
	if(index(XYZ(J),'6/').ne.0) T(J)=6
	if(index(XYZ(J),'7/').ne.0) T(J)=7
	if(index(XYZ(J),'8/').ne.0) T(J)=8
	if(index(XYZ(J),'9/').ne.0) T(J)=9
   10 continue

      do 20 J=1,3
	if(index(XYZ(J),'/2').ne.0) T(J)=T(J)/2
	if(index(XYZ(J),'/3').ne.0) T(J)=T(J)/3
	if(index(XYZ(J),'/4').ne.0) T(J)=T(J)/4
	if(index(XYZ(J),'/6').ne.0) T(J)=T(J)/6
   20 continue

      do 30 J=1,3
	if(index(XYZ(J),'-1').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-2').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-3').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-4').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-5').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-6').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-7').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-8').ne.0) T(J)=-T(J)
	if(index(XYZ(J),'-9').ne.0) T(J)=-T(J)
   30 continue

      do 50 J=1,3
	if(index(XYZ(J),'-X').ne.0) then
	  R(J,1)=-1
	else if(index(XYZ(J),'X').ne.0) then
	  R(J,1)=+1
	end if
	if(index(XYZ(J),'-Y').ne.0) then
	  R(J,2)=-1
	else if(index(XYZ(J),'Y').ne.0) then
	  R(J,2)=+1
	end if
	if(index(XYZ(J),'-Z').ne.0) then
	  R(J,3)=-1
	else if(index(XYZ(J),'Z').ne.0) then
	  R(J,3)=+1
	end if
   50 continue

      end

      subroutine ROTEUL(L,YR,MROT,LROT)
** rotation by Euler angles
** Version 01.02.96
** unrotated cartesian coordinates are in RXYZ
** rotated cartesian coordinates are in RXYZ
** If LROT is .false., the molecule will not be rotated, only the
** rotation matrix will be calculated
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS, XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
** RXYZ(J,I,M): Cartesian coordinates of atom no. I, position M 
**              (before/after rotation, before translation)
** YR(L,J):     Euler angles of molecule/ion no. L
** MROT(I,J):   rotation matrix, I: line number, J: column number
** LROT:        .true.: calculate rotation matrix, do rotation
**              .false.: calculate rotation matrix, do not do rotation
      real RXYZ(3,NUMATM,NUSYM),XYZ(3)
      real YR(NUCLUS,3), MROT(3,3)
      logical LROT
      common /RXYZ/ RXYZ
      SA=sin(YR(L,1))
      CA=cos(YR(L,1))
      SB=sin(YR(L,2))
      CB=cos(YR(L,2))
      SC=sin(YR(L,3))
      CC=cos(YR(L,3))
      MROT(1,1)=CA*CC-SA*CB*SC
      MROT(1,2)=SA*CC+CA*CB*SC
      MROT(1,3)=SB*SC
      MROT(2,1)=-SA*CB*CC-CA*SC
      MROT(2,2)=-SA*SC+CA*CB*CC
      MROT(2,3)=SB*CC
      MROT(3,1)=SA*SB
      MROT(3,2)=-CA*SB
      MROT(3,3)=CB
      if(.not.LROT) goto 999
      do 50 I=1,NATM1
	if(ICLUS(I).eq.L) then
	  do 30 J=1,3
	    XYZ(J) = 0.0
	    do 20 K=1,3
	      XYZ(J) = XYZ(J) + MROT(J,K)*RXYZ(K,I,1)
   20       continue
   30     continue
	  do 40 J=1,3
	    RXYZ(J,I,1) = XYZ(J)
   40     continue
	end if
   50 continue
  999 continue
      end

      subroutine PLTCEL(AC,FAC,AMIN,AMAX,ROTATE,ISTER)
** Plot unit cell
      real AC(8,3),AMIN(3),AMAX(3),ROTATE(3,3),R0(3)
      INTEGER IBO(3,8)
** Unit cell edges
      data ((IBO(I,J),I=1,3),J=1,8) /2,3,4, 1,6,7, 1,5,7, 1,5,6,
     $                               3,4,8, 2,4,8, 2,3,8, 5,6,7/

** Sinus and cosinus of 5 degrees
      S1=0.087156
      C1=0.996195
      BMIN=min(AMIN(1),AMIN(2),AMIN(3))
      BMAX=max(AMAX(1),AMAX(2),AMAX(3))
      YC=0.0
      if(ISTER.ne.0) YC=(BMAX-BMIN)/2.0
**      R0(1)=(AMAX(1)+AMIN(1)+0.3)/2
**      R0(2)=(AMAX(2)+AMIN(2)+0.3)/2
**      R0(3)=(AMAX(3)+AMIN(3)+0.3)/2
      R0(1)=FAC
      R0(2)=FAC
      R0(3)=FAC
      DO 20 I=1,8
        XX=ROTATE(1,1)*(AC(I,1)-R0(1))+ROTATE(1,2)*(AC(I,2)-R0(2))+
     $     ROTATE(1,3)*(AC(I,3)-R0(3))
        YY=ROTATE(2,1)*(AC(I,1)-R0(1))+ROTATE(2,2)*(AC(I,2)-R0(2))+
     $     ROTATE(2,3)*(AC(I,3)-R0(3))
        ZZ=ROTATE(3,1)*(AC(I,1)-R0(1))+ROTATE(3,2)*(AC(I,2)-R0(2))+
     $     ROTATE(3,3)*(AC(I,3)-R0(3))
        X1=XX+(BMAX-BMIN)/2.0+0.15
        Y1=YY+(BMAX-BMIN)/2.0+0.15
        XA=XX*C1+ISTER*ZZ*S1+(BMAX-BMIN)/2.0+0.15
        DO 10 J=1,3
          K=IBO(J,I)
          IF(K.LT.I) GOTO 10
** Choose color of the edge
          IF(I.EQ.1) THEN
            IF(K.EQ.2) CALL NEWPEN(7)
            IF(K.EQ.3) CALL NEWPEN(4)
            IF(K.EQ.4) CALL NEWPEN(2)
          ELSE
            CALL NEWPEN(1)
          END IF
** Calculate the positions of the corners of the rotated unit cell
          XX=ROTATE(1,1)*(AC(K,1)-R0(1))+ROTATE(1,2)*(AC(K,2)-R0(2))+
     $       ROTATE(1,3)*(AC(K,3)-R0(3))
          YY=ROTATE(2,1)*(AC(K,1)-R0(1))+ROTATE(2,2)*(AC(K,2)-R0(2))+
     $       ROTATE(2,3)*(AC(K,3)-R0(3))
          ZZ=ROTATE(3,1)*(AC(K,1)-R0(1))+ROTATE(3,2)*(AC(K,2)-R0(2))+
     $       ROTATE(3,3)*(AC(K,3)-R0(3))
          X2=XX+(BMAX-BMIN)/2.0+0.15
          Y2=YY+(BMAX-BMIN)/2.0+0.15
**      Plot one edge
          call PLOT(X1,Y1+YC,3)
          call PLOT(X2,Y2+YC,2)
**      Second part of the stereo image
          if(ISTER.ne.0) then
            XB=XX*C1+ISTER*ZZ*S1+(BMAX-BMIN)/2.0+0.15
            call PLOT(XA+BMAX-BMIN,Y1+YC,3)
            call PLOT(XB+BMAX-BMIN,Y2+YC,2)
          end if
   10   CONTINUE
   20 CONTINUE
      end

      subroutine PLTMOL(FAC,AMIN,AMAX,MXCOL,ROTATE,ISTER)
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS, XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      real AMIN(3),AMAX(3)
      real RXYZ(3,NUMATM,NUSYM)
      common /RXYZ/ RXYZ
      INTEGER IBO(0:8,NUMATM)
      COMMON /BOND/ IBO
      real A(3,3), AI(3,3)
      common /TEST/ A,AI
      integer ICOL(0:100),ATNO
      real ROTATE(3,3),R0(3)
      data (ICOL(I),I=0,18)/15,15,14,4,2,7,7,2,4,2,7,5,7,7,7,2,14,2,4/
      do 100 I=19,100
        ICOL(I)=MXCOL-1
  100 continue
      call BONDMA
      S1=0.087156
      C1=0.996195
      BMIN=min(AMIN(1),AMIN(2),AMIN(3))
      BMAX=max(AMAX(1),AMAX(2),AMAX(3))
      YC=0.0
      if(ISTER.ne.0) YC=(BMAX-BMIN)/2.0
** Drehpunkt: (AMAX(J)+AMIN(J))/2
      R0(1)=FAC
      R0(2)=FAC
      R0(3)=FAC
**      R0(1)=(AMAX(1)+AMIN(1)+0.3)/2
**      R0(2)=(AMAX(2)+AMIN(2)+0.3)/2
**      R0(3)=(AMAX(3)+AMIN(3)+0.3)/2
      do 10 IC1=0,min(1,ISUM(1))
      do 10 IC2=0,min(1,ISUM(2))
      do 10 IC3=0,min(1,ISUM(3))
      do 10 M=1,NS
        do 10 I=1,NATM1
          X1=RXYZ(1,I,M)+IC1*A(1,1)+IC2*A(1,2)+IC3*A(1,3)-R0(1)
          Y1=RXYZ(2,I,M)+IC1*A(2,1)+IC2*A(2,2)+IC3*A(2,3)-R0(2)
          Z1=RXYZ(3,I,M)+IC1*A(3,1)+IC2*A(3,2)+IC3*A(3,3)-R0(3)
          XX=ROTATE(1,1)*X1+ROTATE(1,2)*Y1+ROTATE(1,3)*Z1
          YY=ROTATE(2,1)*X1+ROTATE(2,2)*Y1+ROTATE(2,3)*Z1
          ZZ=ROTATE(3,1)*X1+ROTATE(3,2)*Y1+ROTATE(3,3)*Z1
          X1=XX+(BMAX-BMIN)/2.0+0.15
          Y1=YY+(BMAX-BMIN)/2.0+0.15
          Z1=ZZ+(BMAX-BMIN)/2.0+0.15
          XB=XX*C1+ISTER*ZZ*S1+1.5*(BMAX-BMIN)+0.15
          if(IBO(0,I).eq.0) then
            call CIRCLE(X1,Y1+YC,0.15)
            if(ISTER.ne.0) then
              call CIRCLE(XB+BMAX-BMIN+0.15,Y1+YC,0.15)
            end if
          end if
          do 20 J=1,IBO(0,I)
            K=IBO(J,I)
            if(K.lt.I) goto 20
            X2=RXYZ(1,K,M)+IC1*A(1,1)+IC2*A(1,2)+IC3*A(1,3)-R0(1)
            Y2=RXYZ(2,K,M)+IC1*A(2,1)+IC2*A(2,2)+IC3*A(2,3)-R0(2)
            Z2=RXYZ(3,K,M)+IC1*A(3,1)+IC2*A(3,2)+IC3*A(3,3)-R0(3)
            XX=ROTATE(1,1)*X2+ROTATE(1,2)*Y2+ROTATE(1,3)*Z2
            YY=ROTATE(2,1)*X2+ROTATE(2,2)*Y2+ROTATE(2,3)*Z2
            ZZ=ROTATE(3,1)*X2+ROTATE(3,2)*Y2+ROTATE(3,3)*Z2
            X2=XX+(BMAX-BMIN)/2.0+0.15
            Y2=YY+(BMAX-BMIN)/2.0+0.15
            Z2=ZZ+(BMAX-BMIN)/2.0+0.15
            if(X1.gt.0.and.Y1+YC.gt.0.and.X2.gt.0.and.Y2+YC.gt.0) then
              call PLOT(X1,Y1+YC,3)
              call NEWPEN(ICOL(ATNO(ATNAME(I))))
              call PLOT((X2-X1)/2.0,(Y2-Y1)/2.0,12)
              call NEWPEN(ICOL(ATNO(ATNAME(K))))
              call PLOT((X2-X1)/2.0,(Y2-Y1)/2.0,12)
            end if
            if(ISTER.ne.0) then
              XC=XX*C1+ISTER*ZZ*S1+1.5*(BMAX-BMIN)+0.15
              if(XB.gt.0.and.Y1+YC.gt.0.and.XC.gt.0.and.Y2+YC.gt.0) then
                call PLOT(XB,Y1+YC,3)
                call NEWPEN(ICOL(ATNO(ATNAME(I))))
                call PLOT((XC-XB)/2.0,(Y2-Y1)/2.0,12)
                call NEWPEN(ICOL(ATNO(ATNAME(K))))
                call PLOT((XC-XB)/2.0,(Y2-Y1)/2.0,12)
              end if
            end if
   20     continue
   10 continue
      end

      subroutine SBROT(N,PHI)
** carry out a subrotation (one part of the molecule is kept unchanged, the
** other part is rotated). N is the number of the subrotation.
** Rotation of the points RXYZ(ISUB(I,N),1), I=1,..,NATM1, around the axis,
** which is given by the directional vector
** RXYZ(ISUB(2,N),1)-RXYZ(ISUB(1,N),1). Rotation angle is PHI
** (radian measure), all coordinates are cartesian coordinates.
** The result is in RXYZ
** Version 23.02.96
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS, XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      real RXYZ(3,NUMATM,NUSYM)
      common /RXYZ/ RXYZ
      parameter(PI=3.141592653589793d0)
      real PHI
      double precision X(3)
************************************************************************
      if(PHI.eq.0.0) goto 9999
      SPHI = sin(PHI)
      CPHI = cos(PHI)
      SA1=SUBDIR(N,1)
      SA2=SUBDIR(N,2)
      CA1=SUBDIR(N,3)
      CA2=SUBDIR(N,4)
      do 500 I=3,NATM1
** IS, not I is the actual number of the atom which is rotated!
	IS = ISUB(I,N)
	if(IS.eq.0) goto 500
	do 10 J=1,3
	  RXYZ(J,IS,1) = RXYZ(J,IS,1) - RXYZ(J,ISUB(1,N),1)
   10   continue
** b) rotation of rotation axis (together with RXYZ) onto x-axis
** 1. rotation around y-axis onto x-y-plane by angle A1
** and 2. around z-axis onto x-axis by angle A2
	X(1) = RXYZ(1,IS,1)*CA1*CA2 -
     $         RXYZ(2,IS,1)*SA2     + RXYZ(3,IS,1)*SA1*CA2
	X(2) = RXYZ(1,IS,1)*CA1*SA2 + 
     $         RXYZ(2,IS,1)*CA2     + RXYZ(3,IS,1)*SA1*SA2
	X(3) =-RXYZ(1,IS,1)*SA1     + RXYZ(3,IS,1)*CA1
	do 30 J=1,3
	  RXYZ(J,IS,1)=X(J)
   30   continue
** c) rotation around x-axis by angle PHI
	X(1) = RXYZ(1,IS,1)
	X(2) =            RXYZ(2,IS,1)*CPHI - RXYZ(3,IS,1)*SPHI
	X(3) =            RXYZ(2,IS,1)*SPHI + RXYZ(3,IS,1)*CPHI
	do 80 J=1,3
	  RXYZ(J,IS,1)=X(J)
   80   continue
** d) return rotation axis (together with RXYZ) to original direction
	X(1) = RXYZ(1,IS,1)*CA1*CA2 +
     $         RXYZ(2,IS,1)*CA1*SA2 - RXYZ(3,IS,1)*SA1
	X(2) =-RXYZ(1,IS,1)*SA2 + RXYZ(2,IS,1)*CA2
	X(3) = RXYZ(1,IS,1)*SA1*CA2 + 
     $         RXYZ(2,IS,1)*SA1*SA2 + RXYZ(3,IS,1)*CA1
	do 100 J=1,3
	  RXYZ(J,IS,1) = X(J)
  100   continue
** e) Shift back RXYZ (s. a))
	do 110 J=1,3
	  RXYZ(J,IS,1) = RXYZ(J,IS,1) + RXYZ(J,ISUB(1,N),1)
  110   continue
  500 continue
 9999 continue
      end

      subroutine BONDMA

** CALCULATES BOND MATRIX
** Version 22.02.96
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS, XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      real DIS
** IBO(0,I) contains the number of atoms bonded to atom no. I
** IBO(J,I) contains the number of the atom bonded to atom no. I
      INTEGER IBO(0:8,NUMATM),ATNO, I1,J1
      COMMON /BOND/ IBO  
      REAL BDRD(100),R1,R2
C * COVALENT BOND RADII 
C * (VCH Verlagsgesellschaft mbH, Periodensystem der Elemente)
      DATA (BDRD(L),L=1,100) /
     $ 0.40, 0.00, 1.23, 0.89, 0.81, 0.77, 0.70, 0.66, 0.64, 0.00,
     $ 1.57, 1.36, 1.25, 1.17, 1.10, 1.04, 0.99, 0.00, 2.03, 1.74,
     $ 1.44, 1.32, 1.22, 1.18, 1.18, 1.16, 1.16, 1.15, 1.17, 1.25,
     $ 1.25, 1.22, 1.21, 1.17, 1.14, 0.00, 2.16, 1.91, 1.62, 1.45,
     $ 1.34, 1.30, 1.27, 1.25, 1.25, 1.28, 1.34, 1.41, 1.50, 1.40,
     $ 1.41, 1.37, 1.33, 0.00, 2.53, 1.98, 1.69, 1.65, 1.65, 1.64,
     $ 1.63, 1.62, 1.85, 1.61, 1.59, 1.59, 1.58, 1.57, 1.56, 1.74,
     $ 1.56, 1.44, 1.34, 1.30, 1.28, 1.26, 1.27, 1.30, 1.34, 1.44,
     $ 1.55, 1.54, 1.46, 1.46, 1.45, 0.00, 0.00, 0.00, 0.00, 1.65,
     $ 0.00, 1.42, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00/
C             
C  *******************
      DO 210 I=1,NATM1
	IBO(0,I)=0
	DO 200 J=1,NATM1
	  IF(I.EQ.J.OR.ICLUS(I).NE.ICLUS(J)) GO TO 200 
C     IF BONDING CONDITION FOUND: 
C     STORE J IN IBO ARRAY 
	  I1=ATNO(ATNAME(I))
	  J1=ATNO(ATNAME(J))
	  if(I1.ne.0) R1=BDRD(I1)
	  if(J1.ne.0) R2=BDRD(J1)
	  if(I1.eq.0) R1=0.0
	  if(J1.eq.0) R2=0.0
	  if(DIS(I,J).lt.1.1*(R1+R2)) then
	    IF(IBO(0,I).GE.8) THEN
	      PRINT *,'MORE THAN 8 BONDS FOR ATOM ',ATNAME(I)
	      GO TO 210
	    END IF
	    IBO(0,I)=IBO(0,I)+1
	    IBO(IBO(0,I),I)=J
	  end if
  200   continue 
  210 continue
      end

      function DIS(I,J)
** CALCULATES DISTANCE BETWEEN ATOM I AND ATOM J
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS,XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      INTEGER I,J
      real DIS
      DIS=sqrt(
     $         (XYZC(I,1)-XYZC(J,1))**2+
     $         (XYZC(I,2)-XYZC(J,2))**2+
     $         (XYZC(I,3)-XYZC(J,3))**2)
      END

      function ATNO(NAME)
** Bestimmt die zu einem Atomnamen gehoerende Ordnungszahl.
** Version 22.02.96
      implicit real (a-h,o-z)
      CHARACTER NAME*8,LOHI*8
      CHARACTER PERIOD(100)*2, TEST*2
      INTEGER ATNO
      COMMON /PERIOD/ PERIOD
      TEST = LOHI(NAME)
      ATNO = 0
      if(ichar(TEST(2:2)).lt.ichar('A').or.
     $   ichar(TEST(2:2)).gt.ichar('Z')) TEST(2:2)=' '
      do 10 J=1,92
        if(TEST.eq.PERIOD(J)) ATNO=J
   10 continue
      end

      block data P
      parameter(NUCLUS=16,NUSUB=8)
      CHARACTER PERIOD(100)*2
      character PNAME(NUCLUS*6+6)*8, RNAME(NUSUB)*8
      COMMON /PERIOD/ PERIOD
      COMMON /PARNAM/ PNAME,RNAME
      DATA (PERIOD(I),I=1,92)/'H ','HE','LI','BE','B ','C ','N ','O ',
     $                        'F ','NE','NA','MG','AL','SI','P ','S ',
     $                        'CL','AR','K ','CA','SC','TI','V ','CR',
     $                        'MN','FE','CO','NI','CU','ZN','GA','GE',
     $                        'AS','SE','BR','KR',
     $                        'RB','SR','Y ','ZR','NB','MO','TC','RU',
     $                        'RH','PD','AG','CD','IN','SN','SB','TE',
     $                        'I ','XE','CS','BA','LA','CE','PR','ND',
     $                        'PM','SM','EU','GD','TB','DY','HO','ER',
     $                        'TM','YB','LU','HF','TA','W ','RE','OS',
     $                        'IR','PT','AU','HG',
     $                        'TL','PB','BI','PO','AT','RN','FR','RA',
     $                        'AC','TH','PA','U '/
      DATA (PNAME(K),K=1,NUCLUS*6+6) /
     $'A','B','C','ALPHA','BETA','GAMMA',
     $'TA1','TB1','TC1','THETA1','CHI1','PHI1',
     $'TA2','TB2','TC2','THETA2','CHI2','PHI2',
     $'TA3','TB3','TC3','THETA3','CHI3','PHI3',
     $'TA4','TB4','TC4','THETA4','CHI4','PHI4',
     $'TA5','TB5','TC5','THETA5','CHI5','PHI5',
     $'TA6','TB6','TC6','THETA6','CHI6','PHI6',
     $'TA7','TB7','TC7','THETA7','CHI7','PHI7',
     $'TA8','TB8','TC8','THETA8','CHI8','PHI8',
     $'TA9','TB9','TC9','THETA9','CHI9','PHI9',
     $'TA10','TB10','TC10','THETA10','CHI10','PHI10',
     $'TA11','TB11','TC11','THETA11','CHI11','PHI11',
     $'TA12','TB12','TC12','THETA12','CHI12','PHI12',
     $'TA13','TB13','TC13','THETA13','CHI13','PHI13',
     $'TA14','TB14','TC14','THETA14','CHI14','PHI14',
     $'TA15','TB15','TC15','THETA15','CHI15','PHI15',
     $'TA16','TB16','TC16','THETA16','CHI16','PHI16'/
      DATA (RNAME(K),K=1,NUSUB) /
     $'PSI1','PSI2','PSI3','PSI4','PSI5','PSI6','PSI7','PSI8'/
      end

      subroutine GRINIT(FAC,XMAX,MXCOL)
      integer*2 IARRAY(9)
      integer MXCOL
      real RARRAY(7)
      CHARACTER*40 STRING
      CALL PLOTS(0,1,18)
      CALL GRINFO(IARRAY,RARRAY,STRING)
      MXCOL=IARRAY(4)
      FAC=RARRAY(1)
      XMAX=RARRAY(2)
      YMAX=RARRAY(3)
      XMAX=min(XMAX,YMAX)
      call NEWPEN(MXCOL-1)
      end

      subroutine CALSYM
** CALCULATES ROTATIONAL PART OF SYMMETRY OPERATIONS, RN (CARTESIAN 
** COORDINATE SYSTEM)
** Version 29.02.96
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS,XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      real X(3),XC(3),Y(3,3)
      real AMAT(3,3), AMATI(3,3)
      common /TEST/ AMAT,AMATI
      do 10 I=1,3
        XC(I)=0.0
   10 continue
**  calculate AMAT and AMATI
      call FRACRT(X,XC,CELL,VOL,-1,UNAX,.false.,IERR)
      do 100 M=1,NS
        N=ISYM(M)
        do 30 K=1,3
          do 20 L=1,3
            Y(K,L) = R(M,K,1)*AMATI(1,L) +
     $               R(M,K,2)*AMATI(2,L) +
     $               R(M,K,3)*AMATI(3,L)
   20     continue
   30   continue
        do 50 K=1,3
          do 40 L=1,3
            if(N.gt.0) then
              RN(N,K,L) = AMAT(K,1)*Y(1,L) +
     $                    AMAT(K,2)*Y(2,L) +
     $                    AMAT(K,3)*Y(3,L)
            else
              RN(-N,K,L) = -AMAT(K,1)*Y(1,L) -
     $                      AMAT(K,2)*Y(2,L) -
     $                      AMAT(K,3)*Y(3,L)
            end if
   40     continue
   50   continue
  100 continue
      end
**
      subroutine OUTPT4(FN)
****** THIS SUBROUTINE WRITES A SCHAKAL FILE
** Version 06.12.95
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS,XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      real F,PC
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      parameter(PI=3.14159265)
      integer FN
      real RXYZ(3,NUMATM,NUSYM)
      real XC(3),XYZ(3)
      common /RXYZ/ RXYZ
      WRITE(FN,'(2A)') 'TITLE ', TITLE(1:65)
      WRITE(FN,'(A,1pe12.4,A)') 'REM E=', F,' kJ/mol'
      WRITE(FN,'(A,6F10.5)') 'CELL ',(CELL(J),J=1,3),
     $                               (CELL(J)/PI*180,J=4,6)
      DO 80 I=1,NATM1
	IF(I.gt.1.and.ICLUS(I).ne.ICLUS(I-1)) WRITE(FN,'(A)') 'MOLE'
	DO 50 J=1,3
	  XC(J)=RXYZ(J,I,1)
   50   CONTINUE
	call FRACRT(XYZ,XC,CELL,VOL,-1,UNAX,.false.,IERR)
**        if(SHIFT) WRITE(FN,'(a4,1x,a4,1x,3(f10.6,1x))') 'ATOM',
**     $               ATNAME(I),(XYZ(J)+mod(XYZS(ICLUS(I),J),1.0),J=1,3)
**        if(.not.SHIFT) WRITE(FN,'(a4,1x,a4,1x,3(f10.6,1x))') 'ATOM',
**     $               ATNAME(I),(XYZ(J)+XYZS(ICLUS(I),J),J=1,3)
	if(SHIFT) WRITE(FN,'(a4,1x,a4,1x,3(f10.6,1x))') 'ATOM',
     $               ATNAME(I),(XYZ(J),J=1,3)
	if(.not.SHIFT) WRITE(FN,'(a4,1x,a4,1x,3(f10.6,1x))') 'ATOM',
     $               ATNAME(I),(XYZ(J),J=1,3)
   80 CONTINUE

      DO 100 M=1,NS
	WRITE(FN,'(A,A)') 'SYMM ',SYMMLS(M)
  100 CONTINUE
      CLOSE(UNIT=FN)
      END
      
      subroutine OUTPT5(FN)
****** THIS SUBROUTINE WRITES A POWDER CELL FILE
** Version 15.03.96
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS,XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      real F,PC
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      parameter(PI=3.14159265)
      integer FN, ATNO
      real RXYZ(3,NUMATM,NUSYM)
      real XC(3),XYZ(3)
      common /RXYZ/ RXYZ

      WRITE(FN,'(A,3(F10.5,1x),3(F10.4,1x))') 'cell ',(CELL(J),J=1,3),
     $                                      (CELL(J)/PI*180,J=4,6)
      WRITE(FN,'(A,I4)') 'natom',NATM1
      DO 80 I=1,NATM1
	DO 50 J=1,3
	  XC(J)=RXYZ(J,I,1)
   50   CONTINUE
	call FRACRT(XYZ,XC,CELL,VOL,-1,UNAX,.false.,IERR)
**        IF(SHIFT) WRITE(FN,'(a,1x,i2,1x,3(f10.6,1x),f5.2)')
**     $                 ATNAME(I)(1:4),ATNO(ATNAME(I)),
**     $                 (XYZ(J)+mod(XYZS(ICLUS(I),J),1.0),J=1,3),1.0
**        IF(.not.SHIFT) WRITE(FN,'(a4,1x,i2,1x,3(f10.6,1x),f5.2)')
**     $                 ATNAME(I)(1:4),ATNO(ATNAME(I)),
**     $                 (XYZ(J)+XYZS(ICLUS(I),J),J=1,3),1.0
        IF(SHIFT) WRITE(FN,'(a,1x,i2,1x,3(f10.6,1x),f5.2)')
     $                 ATNAME(I)(1:4),ATNO(ATNAME(I)),
     $                 (XYZ(J),J=1,3),1.0
	IF(.not.SHIFT) WRITE(FN,'(a4,1x,i2,1x,3(f10.6,1x),f5.2)')
     $                 ATNAME(I)(1:4),ATNO(ATNAME(I)),
     $                 (XYZ(J),J=1,3),1.0
   80 CONTINUE
      WRITE(FN,'(A,I4)') 'rgnr',-1
      WRITE(FN,'(A)') TITLE
      WRITE(FN,'(A,1pe12.4,A)') 'E=', F,' kJ/mol'
      CLOSE(UNIT=FN)
      END
**
      subroutine SYMMCL(BLTP,ICNT)
** INCLUDES TRANSLATIONS AND CENTER OF SYMMETRY
** WRITES SYMMLS
** CREATES LIST OF DIFFERENT ROTATIONS
** Version 20.02.98
************************************************************************
** VARIABLES IN THE COMMON BLOCK:
** ATNAME(I)    c name of atom no. I
** ICENT(J)     i centricity code (1,1,1: inversion center, 1,1,0: 2-fold
**                axis, 1,0,0: mirror plane)
** ICLUS(I)     i number of the molecule/ion of atom no. I
** IPAR(K)      i parameter number of variable no. K
**                Sometimes one variable corresponds to more than one 
**                parameter. In this case IPAR(K) is only one of those 
**                parameters.
** ISPC(L)      i number of symmetry operations which can reproduce 
**                position of molecule/ion no. L
** ISUB(L,N)    i number of Lth atom taking part in Nth subrotation
** ISYM(K)      i number of symmetry dependent orientation of symmetry
**                operation no. K. ISYM(K)<0: molecules must be inverted
** IVAR(I)      i negativ: parameter no. I is negative variable no. -IVAR(I)
**                positiv: parameter no. I is variable no. IVAR(I)
**                zero: parameter no. I is fixed
**                -9999: parameter no. I does not exist
**                Parameters from I=1 to I=6 are cell constants.
**                Parameters from (NUCLUS+1)*6+1 to (NUCLUS+1)*6+NUSUB are
**                subrotations
** LSUB(I)      i no. of the subrotation including atom no. I
**                The atom can be part of 2 subrotations. Therefore LSUB
**                consists of 2 contributions: N1+128*N2. N2 is always the
**                higher subrotating group.
**                0: atom no. I does not take part in any subrotation
**                N1/N2 negativ: atom no. I is one of the two subrotation 
**                defining atoms. These atoms connect group -N1 with group -N2.
** HMIN         r minimum height of the unit cell
** MXR(L)       r maximum radius of molecule/ion no. L (+ van der Waals radius)
** NATM1        i number of atoms in asymmetric unit
** NCH          i number of charges in unit cell
** NCLUS        i number of molecules/ions in asymmetric unit (different 
**                from the constant NUCLUS!)
** NPOT         i number of atom types
** NS           i number of equivalent positions (number of symmetries)
** NSUB         i number of subrotations
** PNAM(M)      c name of atom type no. M
** POT(I,J,K)   r potential parameters for atom type pair I,J, K=1..4
** PRESS        r pressure on the crystal measured in Pa
** PTNAME       c name of potential (12-6, 9-6 ...)
** PTYP(I)      i atom type of atom no. I
** Q(I)         r charge of atom no. I measured in e
** R(K,J,L)     i rotational part of symmetry operation no. K (crystal
**                coordinate system)
** RM(I)        r relative mass of atom no. I
** RN(N,J,L)    r rotational part of symmetry operation (cartesian
**                coordinate system, N=ISYM(K), K=number of symmetry
**                operation)
** SPC(M,L)     c symmetry operation no. M to reproduce position of
**                molecule/ion no. L (special position), e.g. '4556'
** SPEC         l .true.: some atoms are on special positions
** SPG          c space group name
** SPOT(I,K)    r parameters for surface potential
** T(K,J)       r translational part of symmetry operation no. K (crystal
**                coordinate system)
** TITLE        c title of the problem
** UNAX:        c unique axis (a, b, c, r)
** VWR(I)       r VdW radius of atom no. I
** XYZC(I,J)    r coordinates of atom no. I (cartesian, origin in center 
**                of the molecule/ion)
** XYZSC(J,L,M) r coordinates of center of molecule/ion no. L (cartesian)
**                M: number of symmetry operation
************************************************************************
** CONSTANTS:
** NUMATM i max. number of atoms in asymmetric unit
** NUSYM  i max. number of symmetry operations
** NUCLUS i max. number of molecules/ions in asymmetric unit
** NPOTL  i max. number of different atom types
** NV     i max. number of variables
** NUSUB  I max. number of subrotations
************************************************************************
      implicit real (a-h,o-z)
      parameter(NUMATM=250,NUSYM=24,NUCLUS=16,NPOTL=16,NV=36,NUSUB=8)
      integer ICENT(3), ISYM(NUSYM), NCH, NPOT
      integer ICLUS(NUMATM),ISUB(NUMATM,NUSUB),LSUB(NUMATM)
      integer NATM1,NCLUS,NS, NSUB, ISPC(NUCLUS), R(NUSYM,3,3)
      integer IVAR((NUCLUS+1)*6+NUSUB),IPAR(NV),PTYP(NUMATM)
      real RM(NUMATM),MXR(NUCLUS),HMIN, VWR(NUMATM)
      real POT(NPOTL,NPOTL,4), SPOT(NPOTL,3), Q(NUMATM)
      real PRESS, RN(NUSYM/4,3,3), T(NUSYM,3)
      real XYZC(NUMATM,3), XYZSC(3,NUCLUS,NUSYM)
      character ATNAME(NUMATM)*8, PTNAME*8,PNAM(NPOTL)*4
      character SPG*8, SYMMLS(NUSYM)*33, UNAX*1
      character SPC(NUSYM,NUCLUS)*5, TITLE*72
      logical SPEC
      common NATM1,NCLUS,ICENT,
     $       HMIN, MXR,Q, NCH, POT, PRESS, SPOT,
     $       ICLUS,XYZSC, IVAR,IPAR, ISUB, ISYM, ISPC,
     $       NPOT, NSUB, NS, T, R, RM, RN, VWR, PTYP, PNAM, SPEC,
     $       SPG,UNAX,SPC,PTNAME,SYMMLS,TITLE
      common /ATOM/ ATNAME,XYZC,LSUB,ILOOP,ISUM,CELL,F,PC

** VARIABLES IN THE COMMON /PARA/ BLOCK:
** CELL(J)       r cell constants to be used for packing (angles in rad. meas.)
** ISUM(J)       i number of neigbouring cells to be used for energy 
**                 calculation
** ROT(L,K)      r rotation angles for cluster no. L (radian measure)
** RMIN(L)       r minimum radius of molecule/ion no. L (Angstroms)
** SHIFT         l allows the subroutines FOPT and GOPT to shift all
**                 molecules into the central unit cell (SHIFT=.true.)
** SUBDIR(K,J)   r direction of rotation axis for subrotation no. K
**                 J=1,..4: sin(A1), sin(A2), cos(A1), cos(A2)
**                 A1: angle to rotate rotation axis onto x-y-plane by y-axis
**                 A2: angle to rotate rotation axis onto x-axis by z-axis
** SUBROT(K)     r subrotation angle no. K (radian measure)
** SUMR          r summation radius for energy calculation
** XYZS(L,J)     r coordinates of center of molecule/ion no. L (fractional)
      real CELL(6), ROT(NUCLUS,3), SUBROT(NUSUB), XYZS(NUCLUS,3)
      real RMIN(NUCLUS), SUBDIR(NUSUB,4), SUMR
      integer ISUM(3)
      logical SHIFT
      common /PARA/ XYZS, ROT, RMIN, SUBROT, SUBDIR, SUMR, SHIFT
************************************************************************
      integer ICNT
      character BLTP*1,SC(-1:1,3)*2
      logical EQUAL1,EQUAL2
      data ((SC(I,J),I=-1,1),J=1,3) /'-X',' ','+X','-Y',' ','+Y',
     $                               '-Z',' ','+Z'/

** face-centered of body-centered
      if(BLTP.eq.'A'.or.BLTP.eq.'B'.or.BLTP.eq.'C'.or.BLTP.eq.'I')then
        if(2*NS.gt.NUSYM) then
          write(2,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          write(*,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          stop
        end if
        do 510 J=1,NS
          do 510 K=1,3
            T(J+NS,K) = T(J,K)
            if(BLTP.eq.'I') T(J+NS,K)=T(J,K)+0.5
            if(K.eq.1.and.(BLTP.eq.'B'.or.BLTP.eq.'C'))
     $                                       T(J+NS,K)=T(J,K)+0.5
            if(K.eq.2.and.(BLTP.eq.'A'.or.BLTP.eq.'C'))
     $                                       T(J+NS,K)=T(J,K)+0.5
            if(K.eq.3.and.(BLTP.eq.'A'.or.BLTP.eq.'B'))
     $                                       T(J+NS,K)=T(J,K)+0.5
            do 510 L=1,3
              R(J+NS,K,L) = R(J,K,L)
  510   continue
        NS = NS*2
      end if
      if(BLTP.eq.'F') then
        if(4*NS.gt.NUSYM) then
          write(2,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          write(*,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          stop
        end if
        do 520 J=1,NS
          do 520 K=1,3
            do 520 M=1,3
            T(J+M*NS,K) = T(J,K)+0.5
            if(K.eq.M) T(J+M*NS,K)=T(J,K)
            do 520 L=1,3
              R(J+M*NS,K,L) = R(J,K,L)
  520   continue
        NS = NS*4
      end if
** rhombohedral
      if(BLTP.eq.'R'.and.UNAX.ne.'R') then
        if(3*NS.gt.NUSYM) then
          write(2,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          write(*,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          stop
        end if
        do 530 J=1,NS
          do 530 K=1,3
            do 530 M=1,2
              if(K.eq.1) then
                if(M.eq.1) T(J+M*NS,K) = T(J,K)+1.0/3
                if(M.ne.1) T(J+M*NS,K) = T(J,K)+2.0/3
              else
                if(M.eq.1) T(J+M*NS,K) = T(J,K)+2.0/3
                if(M.ne.1) T(J+M*NS,K) = T(J,K)+1.0/3
              end if
              do 530 L=1,3
                R(J+M*NS,K,L) = R(J,K,L)
  530   continue
        NS = NS*3
      end if
** centrosymmetric
      if(ICNT.eq.1) then
        if(2*NS.gt.NUSYM) then
          write(2,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          write(*,'(/1x,a,i3,a/)') 
     $         'ERROR - TOO MANY SYMMETRY OPERATIONS (MORE THAN',NUSYM,
     $         '). PROGRAM ABORTED.'
          stop
        end if
        do 540 J=1,NS
          do 540 K=1,3
            T(J+NS,K) = 1.0-T(J,K)
              do 540 L=1,3
                R(J+NS,K,L) = -R(J,K,L)
  540   continue
        NS = NS*2
      end if
      do 700 I=1,NS
        SYMMLS(I)=' '
        SYMMLS(I)(11:11)=','
        SYMMLS(I)(22:22)=','
        do 590 J=1,3
          if(abs(1./6-abs(T(I,J)) ).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='1/6'
          if(abs(1./4-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='1/4'
          if(abs(1./3-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='1/3'
          if(abs(1./2-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='1/2'
          if(abs(2./3-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='2/3'
          if(abs(3./4-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='3/4'
          if(abs(5./6-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='5/6'
          if(abs(7./6-abs(T(I,J))).lt.1e-4) 
     $                               SYMMLS(I)(J*11-9:J*11-7)='7/6'
          if(T(I,J).lt.0.0) SYMMLS(I)(J*11-10:J*11-10)='-'
          do 580 K=1,3
            SYMMLS(I)(J*11+K*2-8:J*11+K*2-7)=SC(R(I,J,K),K)
  580     continue
  590   continue
** Delete spaces
        do 610 K=1,9
          do 600 J=1,32
            if(SYMMLS(I)(J:J).eq.' ') then
              SYMMLS(I)=SYMMLS(I)(1:J-1)//SYMMLS(I)(J+1:33)//' '
            end if
  600     continue
  610   continue
** Delete leading '+' characters
        if(SYMMLS(I)(1:1).eq.'+') SYMMLS(I)=SYMMLS(I)(2:33)//' '
        do 620 K=1,2
          KI=index(SYMMLS(I),',+')
          if(KI.ne.0) SYMMLS(I)=SYMMLS(I)(1:KI)//SYMMLS(I)(KI+2:33)//' '
  620   continue
  700 continue
** create list of different orientations
      NSYM=0
      EQUAL1=.false.
      EQUAL2=.false.
      do 750 M=1,NS
        do 740 N=1,M-1
          EQUAL1=.true.
          EQUAL2=.true.
          do 730 J=1,3
            do 720 K=1,3
              if(R(M,J,K).ne.R(N,J,K)) then
                EQUAL1=.false.
              end if
              if(R(M,J,K).ne.-R(N,J,K)) then
                EQUAL2=.false.
              end if
  720       continue
  730     continue
          if(EQUAL1) then
            ISYM(M)=ISYM(N)
            goto 750
          else if(EQUAL2) then
            ISYM(M)=-ISYM(N)
            goto 750
          end if
  740   continue
        if(.not.EQUAL1.and..not.EQUAL2) then
          NSYM=NSYM+1
          ISYM(M)=NSYM
        end if
        if(NSYM.gt.NUSYM/4) then
          write(2,'(/1x,a,i3,a/a/)') 
     $         'ERROR - TOO MANY DIFFERENT ORIENTATIONS (MORE THAN',
     $          NUSYM/4,')',' FOR THIS SPACE GROUP. PROGRAM ABORTED.'
          write(*,'(/1x,a,i3,a/a/)') 
     $         'ERROR - TOO MANY DIFFERENT ORIENTATIONS (MORE THAN',
     $          NUSYM/4,')',' FOR THIS SPACE GROUP. PROGRAM ABORTED.'
          stop
        end if
  750 continue
      end
