      program HISTAB
** version 31.10.1997
      parameter(NUSUB=8,PI=3.14159265,NUMATM=200,NUSYM=24,NUCLUS=16)
      parameter(NULOOP=360)
      real X(NULOOP,NUCLUS*6+6+NUSUB),CELL(6)
      real F(NULOOP)
      integer FN,LOPMIN,LOPMAX
      logical LOOP(NULOOP),IDFND
      character*40 FNAME
      CHARACTER LINE*132, FELD*12, SPACE(NULOOP)*8, SPG*8
      character LID*8,LOHI*8
      FN=10
      LOPMIN=3000
      LOPMAX=-3000
      do 1 I=1,NULOOP
	LOOP(I)=.false.
	F(I)=0.0
   1  continue
      open(unit=7,file='packmain.inp',status='old',err=970)
      read(7,'(a)') FNAME
      IFN=index(FNAME,' ')
      open(unit=FN,file=FNAME(:IFN-1)//'.his',err=965,status='old')
      rewind(unit=FN)
      write(*,'(1x,a/)') 'Read history file'
   30 continue
      READ(FN,'(A)',ERR=30,END=100) LINE
***
      LID = LOHI(LINE(1:8))

*** TITLE
      IF(LID(1:3).EQ.'TI ') THEN
	IDFND=.true.
      END IF

*** LOOP
      IF(LID(1:5).EQ.'LOOP ') THEN
	IDFND=.true.
	NP=0
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,I12)',ERR=30) ILOOP
        if(ILOOP.lt.1.or.ILOOP.gt.NULOOP) write(2,'(/1x,a,i12/)') 
     $      'WARNING - ILLEGAL VALUE FOR ILOOP:',ILOOP
        if(ILOOP.lt.1.or.ILOOP.gt.NULOOP) write(*,'(/1x,a,i12/)') 
     $      'WARNING - ILLEGAL VALUE FOR ILOOP:',ILOOP
	call LINCUT(LINE,FELD)
	LOPMIN=min(ILOOP,LOPMIN)
	LOPMAX=max(ILOOP,LOPMAX)
	LOOP(ILOOP)=.true.
        SPACE(ILOOP)=SPG
        write(*,'(''+'',i4)') ILOOP
      END IF

*** NCLUS, NSUB

      IF(LID(1:6).EQ.'NCLUS ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,I12)',ERR=30) NCLUS
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,I12)',ERR=30) NSUB
      END IF

*** CELL CONSTANTS
      IF(LID(1:5).EQ.'CELL ') THEN
	IDFND=.true.
	DO 80 J=1,6
	  CALL LINCUT(LINE,FELD)
          READ(FELD,'(BN,F12.0)',ERR=30) CELL(J)
	  X(ILOOP,J)=CELL(J)
   80   CONTINUE
      END IF

*** SPACE GROUP
      IF(LID(1:5).EQ.'SPGR ') THEN
	IDFND=.true.
        CALL LINCUT(LINE,FELD)
        SPG=FELD
      END IF

*** SYMMETRY
      IF(LID(1:3).EQ.'SY ') THEN
	IDFND=.true.
      END IF

*** ATOM
      IF(LID(1:3).EQ.'AT ') THEN
	IDFND=.true.
      END IF

*** PARAMETERS
      IF(LID(1:5).EQ.'PARM ') THEN
	IDFND=.true.
	NP=NP+1
	do 110 J=1,6
	  call LINCUT(LINE,FELD)
          READ(FELD,'(BN,F12.0)',ERR=30) X(ILOOP,NP*6+J)
  110   continue
	if(NP.le.NCLUS) then
	  do 120 J=4,6
            X(ILOOP,NP*6+J) = X(ILOOP,NP*6+J)*180/PI
  120     continue
	else
	  do 130 J=1,6
            X(ILOOP,NP*6+J) = X(ILOOP,NP*6+J)*180/PI
  130     continue
	end if
      END IF

** ENERGY
      IF(LID(1:3).EQ.'F: ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
        READ(FELD,'(BN,F12.0)',ERR=30) F(ILOOP)
        F(ILOOP)=min(F(ILOOP),99999.0)
      END IF

      if(.not.IDFND) then
	write(*,'(/1x,3a/)') 
     $      'WARNING - LINE ID ',LID,' not found.'
      end if

      goto 30
  100 continue
      open(unit=11,file=FNAME(:IFN-1)//'.tbl',err=975,status='unknown')
      print*,'Write table'
      do 200 I=LOPMIN,LOPMAX
        if(LOOP(I)) then
          write(11,'(i4,f10.3,1x,a,3f9.3,3f7.2,18(6f9.3))') I,F(I)
     $         ,SPACE(I),(X(I,J),J=1,6+NCLUS*6+NSUB)
        end if
  200 continue
      close(FN)
      close(11)
  850 continue
      stop
  965 continue
      print*,'ERROR - Error opening ',FNAME(:IFN-1)//'.his'
      print*,'Program stopped'
      stop
  970 continue
      print*,'ERROR - Error opening packmain.inp'
      print*,'Program stopped'
      stop
  975 continue
      print*,'ERROR - Error opening ',FNAME(:IFN-1)//'.tbl'
      print*,'Program stopped'
      stop
      end
**      
      function LOHI(STRING)
** converts small letters to capital letters
      character*8 STRING,LOHI
      integer IC
      IC = ichar('a')-ichar('A')
      do 10 I=1,8
	if(STRING(I:I).ge.'a'.and.STRING(I:I).le.'z') then
	  LOHI(I:I) = char(ichar(STRING(I:I))-IC)
	else
	  LOHI(I:I) = STRING(I:I)
	end if
   10 continue
      end
**
      subroutine LINCUT(LINE,FELD)
** Searches for the first and second position in the character variable LINE
** where a space or a comma is followed by a character which is neither a
** space or a comma. The region between both positions is transferred to
** the character variable FELD and afterwards cut from the variable LINE.
*** VERSION 6.3.92
      implicit real (a-h,o-z)
      CHARACTER LINE*132, FELD*12
      INTEGER CUT
************************************************************************
      FELD=' '
      CUT=0
      DO 10 I=1,131
	IF((LINE(I:I).EQ.' '.OR.LINE(I:I).EQ.',').AND.
     $     (LINE(I+1:I+1).NE.' '.AND.LINE(I+1:I+1).NE.',')) THEN
	  LINE = LINE(I+1:)
	  CUT=1
	  GOTO 20
	END IF
   10 CONTINUE
   20 CONTINUE
      IF(CUT.NE.1) LINE = ' '
      FELD = LINE
      DO 30 I=1,131
	IF((LINE(I:I).EQ.' '.OR.LINE(I:I).EQ.',').AND.
     $     (LINE(I+1:I+1).NE.' '.AND.LINE(I+1:I+1).NE.',')) THEN
	  FELD = LINE(:I)
	  RETURN
	END IF
   30 CONTINUE
      END
