      program SRTHIS
** version 31.10.1997
      parameter(NUSUB=8,PI=3.14159265,NUMATM=200,NUSYM=24,NUCLUS=16)
      parameter(NULOOP=359)
      real X(NULOOP,6+NUCLUS*6+NUSUB)
      real F(NULOOP),PC(NULOOP),D((NULOOP+1)*NULOOP/2)
      real FM(NULOOP),FA(NULOOP)
      real CELL(6)
      integer JMIN(NULOOP),ICLUS(NULOOP),IDCLUS(NULOOP)
      integer ILOOP
      logical LOOP(NULOOP)
      character CT*16,METHOD*1

** D(I*(I+1)/2+K-I) r Square root of sum of square differences between
**            corresponding parameters of structure no. I and K
** F(I)     r Energy of structure no. I
** FA(L)    r Average energy of cluster no. L
** FM(L)    r Minimum energy of cluster no. L
** ICLUS(I) i Cluster number of structure no. I
** JMIN(L)  i Number of minimum energy structure of cluster no. L
** LOOP(I)  i .true.: structure no. I exists
**            .false.: structure no. I does not exist
** PC(I)    r Packing coefficient of structure no. I
** X(I,J)   r Parameters of structure no. I

      integer LOPMIN,LOPMAX,FN
      CHARACTER LINE*132, FELD*12
      character FNAME*40,LID*8,TITLE*72,LOHI*8
      logical FOUND,IDFND
      do 1 I=1,NULOOP
	LOOP(I)=.false.
	F(I)=0.0
	PC(I)=0.0
	ICLUS(I)=0
   1  continue
      FN=10
      open(unit=7,file='packmain.inp',err=970,status='old')
      read(7,'(a)') FNAME
      close(unit=7)
      write(*,'(1x,72a)') ('*',J=1,72)
      write(*,'(1x,2a,t73,a)')
     $   '*',' PROGRAM SORT, Version October 24, 1997 ','*'
      write(*,'(1x,a1,1x,2a,i4,t73,a)') '*',FNAME,' NULOOP:',NULOOP,'*'
      write(*,'(1x,72a)') ('*',J=1,72)
      IFN=index(FNAME,' ')
      write(*,'(1x,a)') 'Read history file'
      open(unit=FN,file=FNAME(:IFN-1)//'.his',err=965,status='old')
      rewind(unit=FN)
      LOPMIN=99999
      LOPMAX=-99999
   20 continue
      READ(FN,'(A)',ERR=20,END=100) LINE
***
      LID = LOHI(LINE(1:8))

** TITLE
      IF(LID(1:6).EQ.'TITLE ') THEN
	IDFND=.true.
	TITLE = LINE(7:80)
      ELSE IF(LID(1:5).EQ.'TITL ') THEN
	IDFND=.true.
	TITLE = LINE(6:80)
      ELSE IF(LID(1:3).EQ.'TI ') THEN
	IDFND=.true.
	TITLE = LINE(4:80)
      END IF

*** CELL CONSTANTS
      IF(LID(1:5).EQ.'CELL ') THEN
	IDFND=.true.
	DO 80 J=1,6
	  CALL LINCUT(LINE,FELD)
	  READ(FELD,'(BN,F12.0)',ERR=20) CELL(J)
	  IF(J.GT.3) CELL(J)=CELL(J)/180.0*PI
   80   CONTINUE
**    calculate cell vector components
        X(ILOOP,1)=CELL(1)
        X(ILOOP,2)=CELL(2)*sin(CELL(6))
        X(ILOOP,3)=CELL(2)*cos(CELL(6))
        X(ILOOP,4)=CELL(3)*cos(CELL(5))
        X(ILOOP,5)=CELL(3)*
     $             (cos(CELL(4))-cos(CELL(5))*cos(CELL(6)))/sin(CELL(6))
        X(ILOOP,6)=CELL(3)*
     $             sqrt(1.0-(X(ILOOP,5)/CELL(3))**2-cos(CELL(5))**2)
      END IF
***
** ATOM NAMES, POTENTIAL TYPES, COORDINATES, CHARGES
      IF(LID(1:5).EQ.'ATOM '.OR.LID(1:3).EQ.'AT ') THEN
	IDFND = .true.
      END IF

** SYMM
      IF(LID(1:3).eq.'SY ') THEN
	IDFND=.true.
      END IF

*** PARAMETERS
      IF(LID(1:5).EQ.'PARM ') THEN
	IDFND=.true.
	NP=NP+1
	do 110 J=1,6
	  call LINCUT(LINE,FELD)
	  READ(FELD,'(BN,F12.0)',ERR=20) X(ILOOP,NP*6+J)
  110   continue
      END IF

** LOOP
      IF(LID(1:5).EQ.'LOOP ') THEN
	IDFND=.true.
	NP=0
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) ILOOP
        if(ILOOP.lt.1.or.ILOOP.gt.NULOOP) write(2,'(/1x,a,i12/)') 
     $      'WARNING - ILLEGAL VALUE FOR ILOOP:',ILOOP
        if(ILOOP.lt.1.or.ILOOP.gt.NULOOP) write(*,'(/1x,a,i12/)') 
     $      'WARNING - ILLEGAL VALUE FOR ILOOP:',ILOOP
	call LINCUT(LINE,FELD)
	LOPMIN=min(ILOOP,LOPMIN)
	LOPMAX=max(ILOOP,LOPMAX)
	LOOP(ILOOP)=.true.
      END IF

** ENERGY
      IF(LID(1:3).EQ.'F: ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,F12.0)',ERR=20) F(ILOOP)
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,F12.0)',ERR=20) PC(ILOOP)
      END IF

** NCLUS, NSUB

      IF(LID(1:6).EQ.'NCLUS ') THEN
	IDFND=.true.
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) NCLUS
	call LINCUT(LINE,FELD)
	call LINCUT(LINE,FELD)
	READ(FELD,'(BN,I12)',ERR=20) NSUB
      END IF

      if(.not.IDFND) then
	write(2,'(/1x,3a/)') 
     $      'WARNING - LINE ID ',LID,' not found.'
	write(*,'(/1x,3a/)') 
     $      'WARNING - LINE ID ',LID,' not found.'
      end if

      goto 20

  100 continue
      close(unit=FN)
      write(*,'(1x,a,i3,a,i3)') 'LOPMIN=',LOPMIN,' LOPMAX=',LOPMAX
      METHOD='P'
*** COMPARE PARAMETERS
      if(METHOD.eq.'p'.or.METHOD.eq.'P') then
  115   continue
        DTOL = 0.1
	CT = ' '
        write(*,'(1x,a)') 'Tolerance? [0.1] '
	read(*,'(a)',err=115) CT
	if(CT.ne.' ') read(CT,'(f12.0)',err=115) DTOL
** Calculate square distances D(I,J)
	do 250 I=LOPMIN,LOPMAX
          do 240 J=LOPMIN,I
	    if(LOOP(I).and.LOOP(J)) then
              IJ=I*(I+1)/2+J-I
              D(IJ) = 0.0
	      do 220 K=7,(NCLUS+1)*6+NSUB
                D(IJ) = D(IJ) + (X(I,K)-X(J,K))**2/(NCLUS*6+NSUB)
  220         continue
	      do 230 K=1,6
                D(IJ) = D(IJ) + (X(I,K)-X(J,K))**2/6
  230         continue
              D(IJ)=sqrt(D(IJ))
              write(*,'(1x,2i4,1pe10.3)') I,J,D(IJ)
	    end if
  240     continue
  250   continue
      end if

      write(*,'(1x,a)') 'Clustering ...'

** Find clusters no. NC
      NC=1
      ICLUS(LOPMIN)=1
  480 continue
      FOUND=.false.
      do 500 I=LOPMIN,LOPMAX
	if(LOOP(I).and.ICLUS(I).ne.NC) goto 500
	do 490 J=LOPMIN,LOPMAX
          IJ=I*(I+1)/2+J-I
          if(J.gt.I) IJ=J*(J+1)/2+I-J
	  if((.not.LOOP(I)).or.(.not.LOOP(J)).or.I.eq.J) goto 490
          if(D(IJ).lt.DTOL.and.ICLUS(J).eq.0) then
	    FOUND=.true.
	    ICLUS(J)=NC
	  end if
  490   continue
  500 continue
      if(FOUND) goto 480
** Is there still any structure without cluster number?
      FOUND=.false.
      do 550 I=LOPMIN,LOPMAX
	if(LOOP(I).and.ICLUS(I).eq.0) then
	  FOUND=.true.
	  NC=NC+1
	  ICLUS(I)=NC
	  goto 560
	end if
  550 continue
  560 continue
      if(FOUND) goto 480
** calculate minimum and average energy of each cluster
      FGMIN=1e30
      do 600 L=1,NC
	FM(L)=1e30
	FSUM=0.0
	NSUM=0
	do 590 J=LOPMIN,LOPMAX
	  if(LOOP(J).and.ICLUS(J).eq.L) then
	    FSUM = FSUM + F(J)
	    NSUM = NSUM + 1
	    if(F(J).lt.FM(L)) then
	      FM(L) = F(J)
	      JMIN(L) = J
	    end if
	  end if
  590   continue
	if(NSUM.eq.0) goto 600
	FA(L) = FSUM/NSUM
	if(FM(L).lt.FGMIN) FGMIN = FM(L)
  600 continue
** sort cluster with increasing minimum energy
      do 700 L=1,NC
	do 690 K=1,NC-L
	  do 650 I=LOPMIN,LOPMAX
	    IDCLUS(I)=ICLUS(I)
  650     continue
	  if(FM(K).gt.FM(K+1)) then
	    do 670 I=LOPMIN,LOPMAX
	      do 660 J=LOPMIN,LOPMAX
		if(LOOP(I).and.LOOP(J).and.
     $             ICLUS(I).eq.K.and.ICLUS(J).eq.K+1) then
		  IDCLUS(I) = K+1
		  IDCLUS(J) = K
		end if
  660         continue
  670       continue
	    FDUM = FA(K)
	    FA(K) = FA(K+1)
	    FA(K+1) = FDUM
	    FDUM = FM(K)
	    FM(K) = FM(K+1)
	    FM(K+1) = FDUM
	    IDUM = JMIN(K)
	    JMIN(K) = JMIN(K+1)
	    JMIN(K+1) = IDUM
	  end if
	do 680 I=LOPMIN,LOPMAX
	  ICLUS(I) = IDCLUS(I)
  680   continue
  690   continue
  700 continue
      open(unit=11,file=FNAME(:IFN-1)//'.sor',err=975,status='unknown')
      write(11,'(a)') TITLE
      write(11,'(a,f5.2)') 'Tolerance: ',DTOL
      do 800 L=1,NC
	write(11,'(a,i3)') 'Cluster No.',L
        write(11,'(2(a,1pg11.4,a,i3,a))') 
     $                     'Minimum Energy:',FM(L),'(',JMIN(L),')',
     $                     ' Average Energy:',FA(L)
	write(11,'(a4,2x,a6,3x,a2,3x,a12)')
     $                             'loop','energy','PC','dist. to min.'
        NSUM=0
        do 790 I=LOPMIN,LOPMAX
	  if(LOOP(I).and.ICLUS(I).eq.L) then
            IJ=I*(I+1)/2+JMIN(L)-I
            if(JMIN(L).gt.I) IJ=JMIN(L)*(JMIN(L)+1)/2+I-JMIN(L)
            write(11,'(i5,1pg10.3,0pf5.2,1x,f8.3)') I,F(I),PC(I),D(IJ)
            NSUM=NSUM+1
	  end if
  790   continue
        write(11,'(i5,a,i4)') NSUM,' Structure(s) in Cluster No.',L
  800 continue
      write(11,'(/a/)') 'Distances between Clusters:'
      do 850 L1=1,NC,10
        write(11,'(/4x,10i7)') (J,J=L1,min(L1+9,NC))
        do 850 L2=L1,NC
          IJ=I*(I+1)/2+J-I
          if(J.gt.I) IJ=J*(J+1)/2+I-J
          write(11,'(i4,10f7.3)') L2,
     $         (D(max(JMIN(L2),JMIN(J))*(max(JMIN(L2),JMIN(J))+1)/2+
     $            min(JMIN(L2),JMIN(J))-max(JMIN(L2),JMIN(J))),
     $                                                J=L1,min(L1+9,L2))
  850 continue
      stop
  965 continue
      print*,'ERROR - Error opening ',FNAME(:IFN-1)//'.his'
      print*,'Program stopped'
      stop
  970 continue
      print*,'ERROR - Error opening packmain.inp'
      print*,'Program stopped'
      stop
  975 continue
      print*,'ERROR - Error opening ',FNAME(:IFN-1)//'.sor'
      print*,'Program stopped'
      stop
      end
**
      subroutine LINCUT(LINE,FELD)
** Searches for the first and second position in the character variable LINE
** where a space or a comma is followed by a character which is neither a
** space or a comma. The region between both positions is transferred to
** the character variable FELD and afterwards cut from the variable LINE.
*** VERSION 6.3.92
      implicit real (a-h,o-z)
      CHARACTER LINE*132, FELD*12
      INTEGER CUT
************************************************************************
      FELD=' '
      CUT=0
      DO 10 I=1,131
	IF((LINE(I:I).EQ.' '.OR.LINE(I:I).EQ.',').AND.
     $     (LINE(I+1:I+1).NE.' '.AND.LINE(I+1:I+1).NE.',')) THEN
	  LINE = LINE(I+1:)
	  CUT=1
	  GOTO 20
	END IF
   10 CONTINUE
   20 CONTINUE
      IF(CUT.NE.1) LINE = ' '
      FELD = LINE
      DO 30 I=1,131
	IF((LINE(I:I).EQ.' '.OR.LINE(I:I).EQ.',').AND.
     $     (LINE(I+1:I+1).NE.' '.AND.LINE(I+1:I+1).NE.',')) THEN
	  FELD = LINE(:I)
	  RETURN
	END IF
   30 CONTINUE
      END
**      
      function LOHI(STRING)
** converts small letters to capital letters
      character*8 STRING,LOHI
      integer IC
      IC = ichar('a')-ichar('A')
      do 10 I=1,8
	if(STRING(I:I).ge.'a'.and.STRING(I:I).le.'z') then
	  LOHI(I:I) = char(ichar(STRING(I:I))-IC)
	else
	  LOHI(I:I) = STRING(I:I)
	end if
   10 continue
      end
